/******************************
RokrDeskPlugin Daemon
by wanggjghost(泪の单翼天使)
Based on Desktop Plugin Kit - ZMyScreenPlugin by Ant-ON
Special thanks to 夏日清泉（Justin.Z）

www.591moto.cn
41245110@qq.com
please keep author information if you redistribute this program

**********************************/


#include "MyPlugin.h"
#include <qtextstream.h>
#include <qwallpaper.h>
#include <AM_LauncherClient.h>
#include <SETUP_SET_Manager.h>

extern "C" HSPlugin * createInstance (HSPluginContext *context)
{
	return ( new MyPluginClass(context) );
}

extern "C" void destroyInstance (HSPlugin *plugin)
{
	#ifdef DEBUG
	FILE* fd = fopen( LOG_PATH, "a" );
	QString str;
	str = "destroyInstance";
	fwrite (str,1,str.length(),fd);
	fclose(fd);
	#endif
	delete plugin;
}

extern "C" bool isActivated ()
{	
	bool activ;	
	
	SETUP_SET_Manager set( DESK_MAIN_CFG, false);
	set.getSettingInfo("Main", "Activated", activ, true);
	
	#ifdef DEBUG
	FILE* fd = fopen( LOG_PATH, "a" );
	QString str;
	if(activ)
	{
		str = "active";
		fwrite (str,1,str.length(),fd);
	}	
	else
	{
		str = "not active";
		fwrite (str,1,str.length(),fd);	
	}
	fclose(fd);
	#endif
	return activ;
}

extern "C" bool isUserRemovable ()
{
	return true;
}

extern "C" int UTIL_GetBatteryLevel(); 
extern "C" int UTIL_GetSignalQuality(); 
//extern "C" bool UTIL_GetPhoneInCall(); 

#if defined DEBUG || defined DEBUG_DOCKBAR
void MyPluginClass::toLog(QString str2)
{
	FILE* fd = fopen( LOG_PATH, "a" );
	QString str;
	str = QString(str2)+"\n";
	fwrite (str,1,str.length(),fd);
	fclose(fd);
}
#endif

MyPluginClass::MyPluginClass(HSPluginContext *context):
		plgContext(context), state(false),bgState(false),timerControl(true),mTimeUP(1000)
{
	#ifdef DEBUG
	toLog("MyPluginClass::MyPluginClass");
	#endif

	parent = plgContext->getPluginContainer();
	
	timer = new QTimer( parent );
	connect( timer, SIGNAL( timeout() ), SLOT( timerEvent() ) );
}
	
MyPluginClass::~MyPluginClass()
{
	#ifdef DEBUG
	toLog("MyPluginClass::~MyPluginClass");
	#endif
	//delete plgView;
}

void MyPluginClass::initialize()
{
	#ifdef DEBUG
	toLog("initialize()");
	#endif
	plugin_init();

	if ( QCopChannel::isRegistered( "EZX/System" ) )
	{
		QCopChannel * pSysChannel = new QCopChannel("EZX/System", this);
		connect(pSysChannel, SIGNAL(received(const QCString &,const QByteArray &)),
				this, SLOT(slotSystemMessage(const QCString &,const QByteArray &)));
	}

	if ( QCopChannel::isRegistered( "/EZX/PHONE/IDLEFOCUS" ) )
	{
		QCopChannel * pFocusChannel = new QCopChannel( "/EZX/PHONE/IDLEFOCUS" , this);
		connect(pFocusChannel, SIGNAL(received(const QCString &,const QByteArray &)),
				this, SLOT(slotSystemMessage(const QCString &,const QByteArray &)));
	}
	
	QCopChannel * pPluginChannel = new QCopChannel( ROKR_CHANNEL , this);
	connect(pPluginChannel, SIGNAL(received(const QCString &,const QByteArray &)),
		this, SLOT(slotSystemMessage(const QCString &,const QByteArray &)));
}

void MyPluginClass::start()
{
	#ifdef DEBUG
	toLog("start()");
	#endif
	state = true;
	//if(bgState == false) {
		//setBG();
	//	bgState = true;
	//}
	if ( !timer->isActive() && timerControl == true )
		timer->start( mTimeUP, false);
}

void MyPluginClass::stop()
{
	#ifdef DEBUG
	toLog("stop()");
	#endif
	//state = false;
	if ( timer->isActive() )
		timer->stop();
}

QString MyPluginClass::getDisplayName() const
{
	return QString(PLUGIN_NAME);
}


HSFrameworkType::HSEventStatus MyPluginClass::handleEvent(
	const HSFrameworkType::HSEvent& event,
		int key)
{
	#ifdef DEBUG
	toLog("key : "+QString::number(key));	
	#endif

	ZConfig cfg( EZX_IDLE, false);
	if( key == KEY_CENTER && event == HSFrameworkType::HS_KEY_RELEASE ) { //ok key
		if(dockBarShow && mDockBarWidgetIndex != -1) {
			ZConfig cfg(DESK_MAIN_CFG, false);
			int type = cfg.readNumEntry("DockBar", QString("Type%1").arg(mDockBarWidgetIndex), 0);
			QString exec = cfg.readEntry("DockBar", QString("Exec%1").arg(mDockBarWidgetIndex), "");
			#ifdef VE66
				AM_LauncherClient::launchAppObject(exec);
			#else
			if(type == 0)
				AM_LauncherClient::launchAppObject(exec);
			else
				system( QString("%1/javaLoad.sh %2 &").arg(DESK_MIAN_PATH).arg(exec) );
			#endif	
		}
	} 	
	if( key == KEY_DOWN && event == HSFrameworkType::HS_KEY_RELEASE ) { //down
		AM_LauncherClient::launchAppObject( cfg.readEntry("NaviKeyPlugin", "ShortcutID1", "") );
	} 
	if( key == KEY_RIGHT && event == HSFrameworkType::HS_KEY_RELEASE ) { //right
		if(dockBarShow) 
		{
			if( mDockBarWidgetIndex < dockBarNum-1 ) 
				mDockBarWidgetIndex++;
			else
				mDockBarWidgetIndex = 0;
			
			timerEvent();
		} 
		else
		{
			AM_LauncherClient::launchAppObject( cfg.readEntry("NaviKeyPlugin", "ShortcutID2", "") );
		}		
	} 
	if( key == KEY_UP && event == HSFrameworkType::HS_KEY_RELEASE )  { //up
		AM_LauncherClient::launchAppObject( cfg.readEntry("NaviKeyPlugin", "ShortcutID3", "") );
	}
	if( key == KEY_LEFT && event == HSFrameworkType::HS_KEY_RELEASE ) {  //left
		if(dockBarShow) 
		{
			if(mDockBarWidgetIndex >=0 && mDockBarWidgetIndex < dockBarNum)
				mDockBarWidgetIndex--;
			else
				mDockBarWidgetIndex = dockBarNum-1;
			timerEvent();	
		}
		else
		{
			AM_LauncherClient::launchAppObject( cfg.readEntry("NaviKeyPlugin", "ShortcutID4", "") );
		}		
	}	
}

QRect MyPluginClass::getPluginGeometry(const QRect& rc_availableRect)
{
	plgnRect = rc_availableRect;
	#ifdef DEBUG
	toLog("getPluginGeometry");
	int x = plgnRect.x();
	int y = plgnRect.y();
	int width = plgnRect.width();
	int height = plgnRect.height();
	toLog(QString::number(x));
	toLog(QString::number(y));
	toLog(QString::number(width));
	toLog(QString::number(height));
	#endif
	return plgnRect;
}

void MyPluginClass::focusIn()
{
	//当前实现方法时 进入桌面
	#ifdef DEBUG
	toLog("focusIn");
	#endif
	mDockBarWidgetIndex = -1;
	timerEvent();
	start();
}

void MyPluginClass::focusIn(int key, QPoint& pos)
{
	//当前实现方法时 进入桌面
	#ifdef DEBUG
	toLog("focusIn"+QString::number(key) );
	#endif	
	mDockBarWidgetIndex = -1;	
	timerEvent();
	start();
}

void MyPluginClass::focusOut(QPoint& pos, const QString& destPluginName)
{
	//当前实现方法时 进入菜单
	#ifdef DEBUG
	toLog("focusOut"+destPluginName);
	#endif
	mDockBarWidgetIndex = -1;
	stop();
}

QPoint MyPluginClass::getFocusPoint() const
{
	return QPoint(1,1);
}

void MyPluginClass::notifyPluginStateChanged(
	HSFrameworkType::HSPluginTransState state,
		const QString& srcPlugin)
{
	#ifdef DEBUG
	toLog("notifyPluginStateChanged");
	#endif
}

void MyPluginClass::setObscured(bool mode)
{
	#ifdef DEBUG
	if(mode == true)
		toLog("setObscured true");
	else
		toLog("setObscured false");
	#endif	
}

void MyPluginClass::slotSystemMessage(const QCString &msg,const QByteArray &)
{
	#ifdef DEBUG
	toLog("plug mes"+msg);
	#endif
	if ( state == false )
		return;

	if ( msg == "LCDOn" || msg == "DPL_BKLGT_RESTORED" ) {
		mDockBarWidgetIndex = -1;
		timerEvent();
		start();
	} 	
	if ( msg == "LCDOff" ) {
		mDockBarWidgetIndex = -1;
		stop();
	}
	if ( msg == "IDLE_FOCUS_IN" ) {
		mDockBarWidgetIndex = -1;
		timerEvent();
		start();
	} 
	if ( msg == "IDLE_FOCUS_OUT" )	{
		mDockBarWidgetIndex = -1;
		stop();
	}
	/*if ( msg == "Stop()" )	{
		stop();
		timerControl = false;
	}
	if ( msg == "Start()" )	{
		start();
		timerControl = true;
	}*/
	if ( msg == "Reload()" )	{
		stop();
		plugin_init();
		//bgState = false;
		start();		
	}
}
void MyPluginClass::plugin_init()
{
	oldBatteryLevel = -1;
	oldSignalLevel = -1;
	mDockBarWidgetIndex = -1; //dockbar初始化为不选中
	
	QString skinName;
	QString skinPath;
	QString skinCfg;

	ZConfig main( DESK_MAIN_CFG, false);
	skinName = main.readEntry("Main", "Skin", "default");
	weatherDataFolder=main.readEntry("Weather","DataFolder","");
	#ifdef DEBUG
	toLog(skinName);
	#endif	
	//mTimeUP = main.readNumEntry("Main", "Timeout", 3000);

	skinPath = QString(DESK_SKIN_PATH)+skinName+"/";
	skinCfg = skinPath+"skin.cfg";
	
	#ifdef DEBUG
	toLog(skinCfg);
	#endif		

	ZConfig config(skinCfg, false);

	//get wall paper
	#ifdef VE66
	ZConfig ezx_theme(EZX_SYSTEM, false);
	QString curSkin = ezx_theme.readEntry("SYS_DISPLAY_SET", "Skin", "");

	

	#else
	ZConfig ezx_theme(EZX_THEME, false);
	QString curSkin = ezx_theme.readEntry("THEME_GROUP_LOG", "CurrentSkin", "");
	#endif
	
	//fix for wall paper zoom
	QString softkeyFile = QString("%1/homescreen_p.ini").arg(curSkin);
	if( ! QFile::exists( softkeyFile ) )
		softkeyFile = QString("%1/common.ini").arg(curSkin);
	ZConfig softkeyCfg(softkeyFile);
	softKeyHeight = softkeyCfg.readNumEntry("ZSoftKey_Right", "Padding_Bottom", 3);
	softKeyHeight += softkeyCfg.readNumEntry("ZSoftKey_Right", "Padding_Top", 3);
	
	// fix for dcf wall paper and big wall paper
	#ifdef VE66
	QString wallPaper = ezx_theme.readEntry("SYS_DISPLAY_SET", "Wallpaper", "");
	#else
	ZConfig wall( ezx_theme.readEntry("THEME_GROUP_LOG", "CurrentTheme", "") );	
	QString wallPaper = wall.readEntry("THEME_CONFIG_TABLE","WallPaper", "");
	#endif
	if(wallPaper.endsWith( QString(".dcf") )) {
		fmIMG.load(skinPath+config.readEntry("Background","MidIMG", ""));	
	} else {	
		fmIMG.load(wallPaper);
		#ifdef VE66
		if(fmIMG.height() != 320 || fmIMG.width() != 240) {
		#else
		if(fmIMG.height() != 320 || fmIMG.width() != 240) {
		#endif
			QImage img = fmIMG.convertToImage();
			
			img = img.smoothScale(320, 240);
			
			fmIMG.convertFromImage(img);	
		}
	}	
	
	centerIMG.load(skinPath+config.readEntry("Background","MidIMG", ""));	
		
	//frameCoverShow
	frameCoverShow=config.readBoolEntry("FramwCover", "Show", false);
	if(	frameCoverShow ) {
		frameCoverIMG.load( skinPath+config.readEntry("FramwCover", "Img", "") );
		frameCoverLeft = config.readNumEntry("FramwCover", "Left", 0);
		frameCoverTop = config.readNumEntry("FramwCover", "Top", 0);	
	} else {
		if( !frameCoverIMG.isNull() )
			frameCoverIMG.resize(0,0);
	}
	
	//Analog
	analogShow=config.readBoolEntry("Analog", "Show", false);
	if(analogShow) 	{
		analogBackIMG.load(skinPath+config.readEntry("Analog", "BackIMG", ""));
		analogCenterIMG.load(skinPath+config.readEntry("Analog", "CenterIMG", ""));
		
		analogMinIMG.load(skinPath+config.readEntry("Analog", "MinIMG", ""));
		analogHourIMG.load(skinPath+config.readEntry("Analog", "HourIMG", ""));
		analogSecShow=config.readBoolEntry("Analog", "SecShow", "");
		if(analogSecShow)
			analogSecIMG.load(skinPath+config.readEntry("Analog", "SecIMG", ""));
		
		analogLeft=config.readNumEntry("Analog", "Left", 0);
		analogTop=config.readNumEntry("Analog", "Top", 0);
	}else{
		if( !analogBackIMG.isNull() )		analogBackIMG.resize(0,0);
		if( !analogCenterIMG.isNull() )	analogCenterIMG.resize(0,0);
		if( !analogMinIMG.isNull() )		analogMinIMG.resize(0,0);
		if( !analogHourIMG.isNull() )		analogHourIMG.resize(0,0);
		if(analogSecShow) {
			if( !analogSecIMG.isNull() )  analogSecIMG.resize(0,0);
		}
	}
	//Digital
	digitalShow=config.readBoolEntry("Digital","Show", false);
	if(digitalShow) {
		digitalFontIMG.load(skinPath+config.readEntry("Digital", "FontIMG", ""));
		digitalSecShow=config.readBoolEntry("Digital", "SecShow", false);
		
		DHLeft=config.readNumEntry("Digital", "HourLeft", 0);
		DHTop=config.readNumEntry("Digital", "HourTop", 0);
		HMLeft=config.readNumEntry("Digital", "Colon0Left", 0);
		HMTop=config.readNumEntry("Digital", "colon0Top", 0);
		DMLeft=config.readNumEntry("Digital", "MinLeft", 0);
		DMTop=config.readNumEntry("Digital", "MinTop", 0);
		MSLeft=config.readNumEntry("Digital", "Colon1Left", 0);
		MSTop=config.readNumEntry("Digital", "colon1Top", 0);
		DSLeft=config.readNumEntry("Digital", "SecLeft", 0);
		DSTop=config.readNumEntry("Digital", "SecTop", 0);
	} else {
		if( !digitalFontIMG.isNull() )	digitalFontIMG.resize(0,0);	
	}
	//Week
	weekShow=config.readBoolEntry("Week", "Show", false);
	if(weekShow) {
		weekResIMG.load(skinPath+config.readEntry("Week", "ResIMG", ""));
		weekLeft=config.readNumEntry("Week", "Left", 0);
		weekTop=config.readNumEntry("Week", "Top", 0);
	} else {
		if( !weekResIMG.isNull() )		weekResIMG.resize(0,0);
	}
	//[Date]
	dateShow=config.readBoolEntry("Date", "Show" , false);
	if(dateShow) {
		dateFontIMG.load(skinPath+config.readEntry("Date", "FontIMG", ""));
		dateYearShow=config.readBoolEntry("Date","YearShow",false);
		yearLeft=config.readNumEntry("Date","YearLeft", 0);
		yearTop=config.readNumEntry("Date","YearTop", 0);
		YMLeft=config.readNumEntry("Date","YMLeft", 0);
		YMTop=config.readNumEntry("Date","YMTop", 0);
		mouLeft=config.readNumEntry("Date","MouLeft", 0);
		mouTop=config.readNumEntry("Date","MouTop", 0);
		MDLeft=config.readNumEntry("Date","MDLeft", 0);
		MDTop=config.readNumEntry("Date","MDTop", 0);
		dayLeft=config.readNumEntry("Date","DayLeft", 0);
		dayTop=config.readNumEntry("Date","DayTop", 0);
	} else {
		if( !dateFontIMG.isNull() )		dateFontIMG.resize(0,0);	
	}
	//[Lunar]
	lunarShow=config.readBoolEntry("Lunar","Show", false);
	if(lunarShow) {
		lunarYearShow=config.readBoolEntry("Lunar","YearShow", false);
		lunarFontSize=config.readNumEntry("Lunar","FontSize",0);
		lunarFontColor=config.readEntry("Lunar","FontColor","").toLong();
		lunarLeft=config.readNumEntry("Lunar","Left",0);
		lunarTop=config.readNumEntry("Lunar","Top",0);
	}

	//weather
	weatherShow=config.readBoolEntry("Weather","Show", false);
	if(weatherShow){
		
		

		//weatherDataFolder+="\weatherinfo.data"
		weatherPicTop=config.readNumEntry("Weather","PicTop",0);
		weatherPicLeft=config.readNumEntry("Weather","PicLeft",0);
		weatherTempTop=config.readNumEntry("Weather","TempTop",0);
		weatherTempLeft=config.readNumEntry("Weather","TempLeft",0);
		weatherTempFontSize=config.readNumEntry("Weather","TempFontSize",0);
		weatherTempFontColor=config.readEntry("Weather","TempFontColor","0").toLong();

		weatherTextTop=config.readNumEntry("Weather","TextTop",0);
		weatherTextLeft=config.readNumEntry("Weather","TextLeft",0);
		weatherTextFontSize=config.readNumEntry("Weather","TextFontSize",0);
		weatherTextFontColor=config.readEntry("Weather","TextFontColor","0").toLong();

		weatherPlaceTop=config.readNumEntry("Weather","PlaceTop",0);
		weatherPlaceLeft=config.readNumEntry("Weather","PlaceLeft",0);
		weatherPlaceFontSize=config.readNumEntry("Weather","PlaceFontSize",0);
		weatherPlaceFontColor=config.readEntry("Weather","PlaceFontColor","0").toLong();
		RefreshTime=config.readNumEntry("Weather","RefreshTime",0);

		ZConfig cityData(weatherDataFolder+"/setup.ini", false);
		QString cityid=cityData.readEntry("SETUP","cityid","");

		////////////*ZConfig does not work well there */////////////////////////
		/*ZConfig weatherData(weatherDataFolder+"/weatherinfo.data", false);

		weatherPic.load(skinPath+"weather/"+weatherData.readEntry(cityid,"img1","0")+".png");
		weatherTemp=weatherData.readEntry(cityid,"temp1","error");
		
		weatherPlace=weatherData.readEntry(cityid,"city1","error");
		*/
		QFile file(weatherDataFolder+"/weatherinfo.data");
		QString line;
		if ( file.open( IO_ReadOnly ) ) {
			QTextStream stream( &file );
		

			while ( !stream.eof() ) {
				line = stream.readLine();
				if(line.contains("["+cityid))
					break;				
			}
			while ( !stream.eof() ) {
				line = stream.readLine();
				if(line.contains("city "))
				{
					weatherPlace=ctr(line.mid(line.find("= ")+2));
					
				}
				else if(line.contains("temp1 "))
				{
					weatherTemp=ctr(line.mid(line.find("= ")+2));
				
				}
				else if(line.contains("img1 "))
				{
					weatherTemp=line.mid(line.find("= ")+2);
					weatherPic.load(skinPath+"weather/"+line.mid(line.find("= ")+2)+".png");
					
				}
				else if(line.contains("weather1 "))
				{
					weatherText=ctr(line.mid(line.find("= ")+2));
					
				}
									
			}
			file.close();
		}

	}
	//[Battery]
	batteryShow=config.readBoolEntry("Battery","Show",false);
	if(batteryShow) {
		batteryLeft=config.readNumEntry("Battery","Left", 0);
		batteryTop=config.readNumEntry("Battery","Top", 0);	
		batteryLevel[0].load( skinPath+config.readEntry("Battery","Level0","") );
		batteryLevel[1].load( skinPath+config.readEntry("Battery","Level1","") );
		batteryLevel[2].load( skinPath+config.readEntry("Battery","Level2","") );
		batteryLevel[3].load( skinPath+config.readEntry("Battery","Level3","") );
	} else {
		for(int i=0;i<4;i++) {
			if( !batteryLevel[i].isNull() )		batteryLevel[i].resize(0,0);		
		}
	}
	//[Signal]
	signalShow=config.readBoolEntry("Signal","Show", false);
	if(signalShow)	{
		signalLeft=config.readNumEntry("Signal","Left",0);
		signalTop=config.readNumEntry("Signal","Top",0);
		signalLevel[0].load( skinPath+config.readEntry("Signal","Level0","") );
		signalLevel[1].load( skinPath+config.readEntry("Signal","Level1","") );
		signalLevel[2].load( skinPath+config.readEntry("Signal","Level2","") );
		signalLevel[3].load( skinPath+config.readEntry("Signal","Level3","") );
		signalLevel[4].load( skinPath+config.readEntry("Signal","Level4","") );
		signalLevel[5].load( skinPath+config.readEntry("Signal","Level5","") );
	} else {
		for(int i=0;i<6;i++) {
			if( !signalLevel[i].isNull() )	signalLevel[i].resize(0,0);	
		}	
	}
	//[Notify]
	notifyShow = config.readBoolEntry("Notify","Show", false);
	if(notifyShow) {
		notifyBold=config.readBoolEntry("Notify","Bold",false);
		notifyFontSize=config.readNumEntry("Notify","FontSize",0);
		notifyLeft=config.readNumEntry("Notify","Left",0);
		notifyTop=config.readNumEntry("Notify","Top",0);
		notifyFontColor=config.readEntry("Notify","FontColor","").toLong();	
		//notifyOffset = 0;
		notifyDestYear = main.readUIntEntry("Notify", "Year", 1987);
		notifyDestMonth = main.readUIntEntry("Notify", "Month", 4);
		if(notifyDestMonth>12 && notifyDestMonth<1)
			notifyDestMonth = 4;			
		notifyDestDay = main.readUIntEntry("Notify", "Day", 6);
		if(notifyDestDay>31 && notifyDestDay<1)
			notifyDestDay = 6;
		notifyStr = main.readEntry("Notify", "Info", " ");
	}
	//[DockBar]	
	dockBarShow = config.readBoolEntry("DockBar","Show", false);
	if(dockBarShow){
		dockBarBgImg.load(skinPath+config.readEntry("DockBar", "BGIMG", ""));
		dockBarBgTop = config.readNumEntry("DockBar","BGTop",0);
		dockBarBgLeft = config.readNumEntry("DockBar","BGLeft",0);
		dockBarNum = config.readNumEntry("DockBar","Num",1);
		dockBarInfoShow = config.readBoolEntry("DockBar","InfoShow", false);
		#ifdef DEBUG_DOCKBAR
		toLog(QString("BGIMG ")+config.readEntry("DockBar", "BGIMG", ""));
		toLog(QString("Top ")+QString::number(dockBarBgTop));
		toLog(QString("Number ")+QString::number(dockBarNum));
		#endif
		for(int i=0;i<dockBarNum;i++){
			dockBarTop[i] = config.readNumEntry("DockBar",QString("Top%1").arg(i),1);
			dockBarLeft[i] = config.readNumEntry("DockBar",QString("Left%1").arg(i),1);
			dockBarSizeHeight[i] = config.readNumEntry("DockBar",QString("SizeHeight%1").arg(i),1);
			dockBarWidgetHeight[i] = config.readNumEntry("DockBar",QString("WidgetHeight%1").arg(i),1);
			dockBarSizeWidth[i] = config.readNumEntry("DockBar",QString("SizeWidth%1").arg(i),1);
			dockBarWidgetWidth[i] = config.readNumEntry("DockBar",QString("WidgetWidth%1").arg(i),1);
			QString tmp = main.readEntry("DockBar", QString("Icon%1").arg(i), skinPath+"dock.png");
			if(	QFile::exists(tmp) ) 
				dockBarIcon[i].load( tmp );
			else 
				dockBarIcon[i] = iconReader.getIcon(tmp);
			
			if(dockBarInfoShow) {
				dockBarInfoFontSize[i] = config.readNumEntry("DockBar",QString("InfoFontSize%1").arg(i),12);
				dockBarInfoFontLeft[i] = config.readNumEntry("DockBar",QString("InfoFontLeft%1").arg(i),0); 
				dockBarInfoFontTop[i] = config.readNumEntry("DockBar",QString("InfoFontTop%1").arg(i),0); 
				dockBarInfoFontColor[i] = config.readEntry("DockBar",QString("InfoFontColor%1").arg(i),"").toLong();		
				dockBarInfoContent[i] = main.readEntry("DockBar", QString("Name%1").arg(i), "test");
			}	
			#ifdef DEBUG_DOCKBAR
			toLog(QString("dock bar ")+QString::number(i));
			toLog(QString::number(dockBarLeft[i]));			
			toLog(QString::number(dockBarTop[i]));
			#endif				
		}	
	} else {
		if( !dockBarBgImg.isNull() )	dockBarBgImg.resize(0,0);
		for(int i=0;i<11;i++) {
			if( !dockBarIcon[i].isNull() )	dockBarIcon[i].resize(0,0);		
		}
	}
}
void MyPluginClass::timerEvent()
{
	nowScreen = fmIMG;
	
	QPainter p(&nowScreen);
	p.begin(&nowScreen);
	
	QFontMetrics fm = p.fontMetrics();
	#ifdef VE66
	nowScreen.resize(240, 295-softKeyHeight-fm.height());
	#else
	nowScreen.resize(240, 296-softKeyHeight-fm.height());
	#endif
	
	//e8 上部宽为20像素
	//ve66 25
	#ifdef VE66
	p.drawPixmap(0,0, fmIMG, 0, 25, fmIMG.width() , 220-softKeyHeight-fm.height());
	#else
	p.drawPixmap(0,0, fmIMG, 0, 20, fmIMG.width() , 301-softKeyHeight-fm.height());	
	#endif
	
	drawCenter(p);
	if(weatherShow)
		drawWeather(p);
	
	if(batteryShow)
		drawBattery(p);
	if(signalShow)	
		drawSignal(p);	
	
	if(digitalShow)
		drawDigital(p);
	if(dateShow)
		drawDate(p);
	if(weekShow)
		drawWeek(p);
	
	if(analogShow)
		drawAnalog(p);

	if(dockBarShow)
		drawDockBar(p);
		
	if(notifyShow)
		drawNotify(p);	
	if(lunarShow)
		drawLunar(p);	

	if(frameCoverShow)
		drawFrameCover(p);			

	p.end();
	
	bitBlt(parent,0,0,&nowScreen,0); 
}
/*
void MyPluginClass::setBG()
{
	//上部宽为20像素
	//int height = fm.height();
	
	//QPixmap tmp = fmIMG;
	
	//QPainter p(&tmp);
	//QFontMetrics fm = p.fontMetrics();
	//p.begin(&tmp);	
	
	//fmIMG.resize(tmp.width(), 220-softKeyHeight-fm.height());
	//tmp.resize(320, 200);

	//p.drawPixmap(0,0, fmIMG, 0, 20, fmIMG.width() , 220-softKeyHeight-fm.height());
	//p.end();
	
	//tmp.save(QString("%1/bg.png").arg(DESK_MIAN_PATH), "PNG");
	//QPixmap bg = QPixmap(QString("%1/bg.png").arg(DESK_MIAN_PATH));
	
	//QWallpaper::setSysWallpaper(&bg);
	//QWallpaper::setSysWallpaper(&bg);
}
*/
void MyPluginClass::drawCenter(QPainter &p)
{
	p.drawPixmap(0,0, centerIMG);//, 0, 20, centerIMG.width(), 220-softKeyHeight-fm.height());
	//p.drawPixmap(0,0, centerIMG, 0, 20, centerIMG.width(), 220-softKeyHeight-fm.height());
}
void MyPluginClass::drawFrameCover(QPainter &p)
{
	p.drawPixmap(frameCoverLeft,frameCoverTop, frameCoverIMG);
}
void MyPluginClass::drawAnalog(QPainter &p)
{
	p.drawPixmap(analogLeft,analogTop,analogBackIMG);
	
	time_t rawtime;
	time ( &rawtime );
	timeinfo = localtime ( &rawtime );
	
	QWMatrix h;                         // transformation matrix

	h.rotate( (float)(timeinfo->tm_hour%12)*30+(float)(timeinfo->tm_min%60)*0.25);
	//printf("\nrotate:%f",(float)(timeinfo->tm_hour%12)*15.0+(float)(timeinfo->tm_min%60)*0.25);
	QPixmap hour = analogHourIMG.xForm( h );  
	p.drawPixmap((analogBackIMG.width()-hour.width())/2+analogLeft,(analogBackIMG.height()-hour.height())/2+analogTop,hour);

	QWMatrix m;                         // transformation matrix

	m.rotate( (float)(timeinfo->tm_min%60)*6.0);
	
	QPixmap min = analogMinIMG.xForm( m );  
	p.drawPixmap((analogBackIMG.width()-min.width())/2+analogLeft,(analogBackIMG.height()-min.height())/2+analogTop,min);

	if(analogSecShow)
	{
		QWMatrix s;                         // transformation matrix

		s.rotate( (float)(timeinfo->tm_sec%60)*6.0);
	
		QPixmap sec = analogSecIMG.xForm( s );  
		p.drawPixmap((analogBackIMG.width()-sec.width())/2+analogLeft,(analogBackIMG.height()-sec.height())/2+analogTop,sec);
	}
}
void MyPluginClass::drawDigital(QPainter &p)
{
	//printf("\ndraw digital\n");
	time_t rawtime;
	time ( &rawtime );
	timeinfo = localtime ( &rawtime );
		
	p.drawPixmap(DHLeft,DHTop,digitalFontIMG,0,timeinfo->tm_hour/10*digitalFontIMG.height()/11,digitalFontIMG.width(),digitalFontIMG.height()/11);
		
	p.drawPixmap(DHLeft+digitalFontIMG.width(),DHTop,digitalFontIMG,0,timeinfo->tm_hour%10*digitalFontIMG.height()/11,digitalFontIMG.width(),digitalFontIMG.height()/11);
	
	p.drawPixmap(HMLeft,HMTop,digitalFontIMG,0,10*digitalFontIMG.height()/11,digitalFontIMG.width(),digitalFontIMG.height()/11);
	
	p.drawPixmap(DMLeft,DMTop,digitalFontIMG,0,timeinfo->tm_min/10*digitalFontIMG.height()/11,digitalFontIMG.width(),digitalFontIMG.height()/11);
		
	p.drawPixmap(DMLeft+digitalFontIMG.width(),DMTop,digitalFontIMG,0,timeinfo->tm_min%10*digitalFontIMG.height()/11,digitalFontIMG.width(),digitalFontIMG.height()/11);
	
	if(digitalSecShow)
	{
		p.drawPixmap(MSLeft,MSTop,digitalFontIMG,0,10*digitalFontIMG.height()/11,digitalFontIMG.width(),digitalFontIMG.height()/11);
	
		p.drawPixmap(DSLeft,DSTop,digitalFontIMG,0,timeinfo->tm_sec/10*digitalFontIMG.height()/11,digitalFontIMG.width(),digitalFontIMG.height()/11);
		
		p.drawPixmap(DSLeft+digitalFontIMG.width(),DSTop,digitalFontIMG,0,timeinfo->tm_sec%10*digitalFontIMG.height()/11,digitalFontIMG.width(),digitalFontIMG.height()/11);
	}	
}
void MyPluginClass::drawDate(QPainter &p)
{
	time_t rawtime;
	time ( &rawtime );
	timeinfo = localtime ( &rawtime );
	Date tdate;
	tdate.year=timeinfo->tm_year+1900;
	tdate.month=timeinfo->tm_mon+1;
	tdate.day=timeinfo->tm_mday;
	
	int yearshow=0;

	if(dateYearShow)
	{
		p.drawPixmap(yearLeft,yearTop,dateFontIMG,0,tdate.year/1000*dateFontIMG.height()/11,dateFontIMG.width(),dateFontIMG.height()/11);
		p.drawPixmap(yearLeft+dateFontIMG.width(),yearTop,dateFontIMG,0,tdate.year%1000/100*dateFontIMG.height()/11,dateFontIMG.width(),dateFontIMG.height()/11);
		p.drawPixmap(yearLeft+dateFontIMG.width()*2,yearTop,dateFontIMG,0,tdate.year%100/10*dateFontIMG.height()/11,dateFontIMG.width(),dateFontIMG.height()/11);
		p.drawPixmap(yearLeft+dateFontIMG.width()*3,yearTop,dateFontIMG,0,tdate.year%10*dateFontIMG.height()/11,dateFontIMG.width(),dateFontIMG.height()/11);
		
		p.drawPixmap(YMLeft,YMTop,dateFontIMG,0,10*dateFontIMG.height()/11,dateFontIMG.width(),dateFontIMG.height()/11);
		yearshow=5;
	}
	
	p.drawPixmap(mouLeft,mouTop,dateFontIMG,0,tdate.month/10*dateFontIMG.height()/11,dateFontIMG.width(),dateFontIMG.height()/11);
		
	p.drawPixmap(mouLeft+dateFontIMG.width(),mouTop,dateFontIMG,0,tdate.month%10*dateFontIMG.height()/11,dateFontIMG.width(),dateFontIMG.height()/11);
		
	p.drawPixmap(MDLeft,MDTop,dateFontIMG,0,10*dateFontIMG.height()/11,dateFontIMG.width(),dateFontIMG.height()/11);
	
	p.drawPixmap(dayLeft,dayTop,dateFontIMG,0,tdate.day/10*dateFontIMG.height()/11,dateFontIMG.width(),dateFontIMG.height()/11);
		
	p.drawPixmap(dayLeft+dateFontIMG.width(),dayTop,dateFontIMG,0,tdate.day%10*dateFontIMG.height()/11,dateFontIMG.width(),dateFontIMG.height()/11);
}
void MyPluginClass::drawLunar(QPainter &p)
{
	time_t rawtime;
	time ( &rawtime );
	timeinfo = localtime ( &rawtime );
	Date tdate;
	tdate.year=timeinfo->tm_year+1900;
	tdate.month=timeinfo->tm_mon+1;
	tdate.day=timeinfo->tm_mday;
	
	QString nltemp;
	GetDayOf(tdate,nltemp);
	if(!lunarYearShow)
	{
		nltemp.mid(nltemp.find(" "));
	}
	QFont f("AMCSL",lunarFontSize);	//设置字体大小
	p.setFont(f);
	QPen pen(lunarFontColor,1);
	p.setPen(pen);

	p.drawText( lunarLeft,lunarTop, nltemp/*ctr(nltemp)*/ );
}
void MyPluginClass::drawWeather(QPainter &p)
{
	/*
	bool weatherShow ;
		QString weatherDataFolder ;
		QPixmap weatherPic;
		int weatherPicTop ;
		int weatherPicLeft;
		int weatherTempTop;
		int weatherTempLeft;
		int weatherTempFontSize;
		long weatherTempFontColor;
		int weatherPlaceTop; 
		int weatherPlaceLeft;
		int weatherPlaceFontSize;
		long weatherPlaceFontColor;
		int RefreshTime;
		QString weatherTemp;
		QString weatherPlace;
*/
	p.drawPixmap(weatherPicLeft, weatherPicTop, weatherPic);
	QFont f("AMCSL",weatherTempFontSize);	//设置字体大小
	p.setFont(f);
	QPen pen(weatherTempFontColor,1);
	p.setPen(pen);

	p.drawText( weatherTempLeft,weatherTempTop,weatherTemp);

	QFont f1("AMCSL",weatherPlaceFontSize);	//设置字体大小
	p.setFont(f1);
	QPen pen1(weatherPlaceFontColor,1);
	p.setPen(pen1);

	p.drawText( weatherPlaceLeft,weatherPlaceTop,weatherPlace );

	QFont f2("AMCSL",weatherTextFontSize);	//设置字体大小
	p.setFont(f2);
	QPen pen2(weatherTextFontColor,1);
	p.setPen(pen2);

	p.drawText( weatherTextLeft,weatherTextTop,weatherText);



}
void MyPluginClass::drawWeek(QPainter &p)
{
	time_t rawtime;
	time ( &rawtime );
	timeinfo = localtime ( &rawtime );
	
	p.drawPixmap(weekLeft,weekTop,weekResIMG,0,weekResIMG.height()/7*timeinfo->tm_wday,weekResIMG.width(),weekResIMG.height()/7);
}
void MyPluginClass::drawBattery(QPainter &p)
{
	if(oldBatteryLevel!=UTIL_GetBatteryLevel())
		oldBatteryLevel=UTIL_GetBatteryLevel();

	int batNum;
	if(oldBatteryLevel>=3)
		batNum=oldBatteryLevel-2;
	else
		batNum=oldBatteryLevel/2;
	
	p.drawPixmap(batteryLeft, batteryTop, batteryLevel[batNum]);

}
void MyPluginClass::drawSignal(QPainter &p)
{
	if(oldSignalLevel!=UTIL_GetSignalQuality())
		oldSignalLevel = UTIL_GetSignalQuality();

	p.drawPixmap(signalLeft, signalTop, signalLevel[oldSignalLevel]);
}
void MyPluginClass::drawNotify(QPainter &p)
{
	QString str;
	QDate date = QDate::currentDate();
	QDate date2(notifyDestYear, notifyDestMonth, notifyDestDay);
	/*int i = date.daysTo(date2);
	if( i > -1 ) 
		str = ctr("%2").arg(notifyStr).arg(i);
	else 
		str = ctr("%2").arg(notifyStr).arg( (uint)i );*/

	QFont f("AMCSL", notifyFontSize);	//设置字体大小
	if(notifyBold)
		f.setBold(true);		
	p.setFont(f);
	
	// text Shadow
	p.setPen(QColor(128,128,128));
	p.drawText( notifyLeft+1 ,notifyTop+1, str );
	
	// text
	QPen pen(notifyFontColor,1);
	p.setPen(pen);
	//QFontMetrics fm = p.fontMetrics();
	
	p.drawText( notifyLeft ,notifyTop, str );
}
void MyPluginClass::drawDockBar(QPainter &p)
{
	#ifdef DEBUG_DOCKBAR
	toLog("draw dock bar");
	#endif
	p.drawPixmap(dockBarBgLeft,dockBarBgTop, dockBarBgImg); //画背景
	
	for(int i=0;i<dockBarNum;i++) {
		#ifdef DEBUG_DOCKBAR
		toLog("draw icon"+QString::number(i));
		#endif
		float a, b;//, c;
		if(i == mDockBarWidgetIndex ) {
			a = (float)dockBarWidgetWidth[i]/(float)dockBarIcon[i].width();
			b = (float)dockBarWidgetHeight[i]/(float)dockBarIcon[i].height();		
		} else {		
			a = (float)dockBarSizeWidth[i]/(float)dockBarIcon[i].width();
			b = (float)dockBarSizeHeight[i]/(float)dockBarIcon[i].height();
		}	
		if(a<0) a = -a;
		if(b<0) b = -b;
		#ifdef DEBUG_DOCKBAR
		toLog("a ,b "+QString::number(a)+QString::number(b));
		#endif		
		QWMatrix tmp;
		tmp.scale(a, b);		
		QPixmap now = dockBarIcon[i].xForm( tmp );
		p.drawPixmap(dockBarLeft[i], dockBarTop[i], now);	
		
		// draw app info
		if(i == mDockBarWidgetIndex ) {
			#ifdef DEBUG_DOCKBAR
			toLog("draw dock bar info index "+QString::number(i));
			#endif	
			if( dockBarInfoShow ) {
				QFont f("AMCSL", dockBarInfoFontSize[i]);	//设置字体大小
				p.setFont(f);				
				// text Shadow
				p.setPen(QColor(128,128,128));
				p.drawText( dockBarInfoFontLeft[i]+1 ,dockBarInfoFontTop[i]+1, dockBarInfoContent[i] );				
				// text
				QPen pen(dockBarInfoFontColor[i],1);
				p.setPen(pen);
				p.drawText( dockBarInfoFontLeft[i], dockBarInfoFontTop[i], dockBarInfoContent[i]);
				#ifdef DEBUG_DOCKBAR
				toLog("draw dock bar info "+ctr(dockBarInfoContent[i]);
				#endif						
			}		
		}
	}
}

void MyPluginClass::GetDayOf(Date &tdate,QString &strLuner) 
{ 
/*天干名称*/ 
const char *cTianGan[] = {" "," "," "," "," "," "," "," "," "," "}; 
/*地支名称*/ 
const char *cDiZhi[] = {" "," "," "," "," "," "," ", 
" "," "," "," "," "}; 
/*属相名称*/ 
const char *cShuXiang[] = {" "," "," "," "," "," ", 
" "," "," "," "," "," "}; 
/*农历日期名*/ 
const char *cDayName[] = {" "," "," "," "," "," ", 
" "," "," "," "," ", 
" "," "," "," "," ", 
" "," "," "," "," ", 
" "," "," "," "," ", 
" "," "," "," "," "}; 
/*农历月份名*/ 
const char *cMonName[] = {" "," "," "," "," "," "," ", 
" "," "," "," "," "," "}; 

/*公历每月前面的天数*/ 
const int wMonthAdd[12] = {0,31,59,90,120,151,181,212,243,273,304,334}; 
/*农历数据*/ 
const int wNongliData[100] = 
{2635,333387,1701,1748,267701,694,2391,133423,1175,396438 
,3402,3749,331177,1453,694,201326,2350,465197,3221,3402 
,400202,2901,1386,267611,605,2349,137515,2709,464533,1738 
,2901,330421,1242,2651,199255,1323,529706,3733,1706,398762 
,2741,1206,267438,2647,1318,204070,3477,461653,1386,2413 
,330077,1197,2637,268877,3365,531109,2900,2922,398042,2395 
,1179,267415,2635,661067,1701,1748,398772,2742,2391,330031 
,1175,1611,200010,3749,527717,1452,2742,332397,2350,3222 
,268949,3402,3493,133973,1386,464219,605,2349,334123,2709 
,2890,267946,2773,592565,1210,2651,395863,1323,2707,265877}; 
static int wCurYear,wCurMonth,wCurDay; 
static int nTheDate,nIsEnd,m,k,n,i,nBit; 
//char szNongli[30], szNongliDay[10],szShuXiang[10]; 
/*---取当前公历年、月、日-- -*/ 
wCurYear = tdate.year; 
wCurMonth = tdate.month; 
wCurDay = tdate.day;
/*---计算到初始时间1921年2月8日的天数：1921-2-8(正月初一)---*/ 
nTheDate = (wCurYear - 1921) * 365 + (wCurYear - 1921) / 4 + wCurDay + wMonthAdd 
[wCurMonth - 1] - 38; 
if((!(wCurYear % 4)) && (wCurMonth > 2)) 
nTheDate = nTheDate + 1; 

/*--计算农历天干、地支、月、日---*/ 
nIsEnd = 0; 
m = 0; 
while(nIsEnd != 1) 
{ 
	if(wNongliData[m] < 4095) 
		k = 11; 
	else 
		k = 12; 
	n = k; 
	while(n>=0) 
	{ 
		//获取wNongliData(m)的第n个二进制位的值 
		nBit = wNongliData[m]; 
		for(i=1;i<n+1;i++) 
		nBit = nBit/2; 

		nBit = nBit % 2; 

		if (nTheDate <= (29 + nBit)) 
		{ 
			nIsEnd = 1; 
			break; 
		} 

		nTheDate = nTheDate - 29 - nBit; 
		n = n - 1; 
	} 
	if(nIsEnd) 
		break; 
	m = m + 1; 
} 
wCurYear = 1921 + m; 
wCurMonth = k - n + 1; 
wCurDay = nTheDate; 
if (k == 12) 
{ 
	if (wCurMonth == wNongliData[m] / 65536 + 1) 
		wCurMonth = 1 - wCurMonth; 
	else if (wCurMonth > wNongliData[m] / 65536 + 1) 
		wCurMonth = wCurMonth - 1; 
} 

/*--生成农历天干、地支、属相 ==> wNongli--*/ 
if(lunarYearShow){
/*strLuner =  ctr( cShuXiang[((wCurYear - 4) % 60) % 12] );
strLuner          +=  ctr(" ");
strLuner          += ctr( cTianGan[((wCurYear - 4) % 60) % 10] );
strLuner          += ctr( cDiZhi[((wCurYear - 4) % 60) % 12] );
strLuner          += ctr( " " );*/
}
/*--生成农历月、日 ==> wNongliDay--*/ 
if (wCurMonth < 1)
{
 	strLuner = strLuner +  ctr( " " )
         	+  ctr( cMonName[-1 * wCurMonth] );
}
else
{
	strLuner = strLuner +  ctr( cMonName[wCurMonth] );
}
strLuner = strLuner +  ctr( " " )
           +  ctr( cDayName[wCurDay] );

} 


