
#ifndef MY_PLUGIN
#define MY_PLUGIN

#include <ZWidget.h>
#include <RES_ICON_Reader.h>

#include <qobject.h>
#include <qtimer.h>
#include <qcopchannel_qws.h>
#include <qpixmap.h>
#include <qwidget.h>
#include <time.h>
#include <qdatetime.h>
#include <qdir.h>

#include <iostream>

#include "HSPlugin.h"
#include "HSPluginContext.h"
#include "HSPluginSettingInfo.h"
#include "HSFrameworkType.h"

#include "myDef.h"
#include "tool.h"

typedef struct tagDate		//ڸʽ
{
  int day;
  int month;
  int year;
}Date,*PDate;


class Q_EXPORT MyPluginClass: public QObject, public HSPlugin
{
	Q_OBJECT
	public:
		MyPluginClass(HSPluginContext *context);
		virtual ~MyPluginClass();
    	void initialize();
    	void start();
    	void stop();
    	QString getDisplayName() const;
    	HSFrameworkType::HSEventStatus handleEvent(const HSFrameworkType::HSEvent& event, int key = -1);
    	QRect getPluginGeometry(const QRect& rc_availableRect);
    	void focusIn();
    	void focusIn(int key, QPoint& pos);
    	void focusOut(QPoint& pos, const QString& destPluginName);
    	QPoint getFocusPoint() const;
    	void notifyPluginStateChanged(HSFrameworkType::HSPluginTransState state,const QString& srcPlugin);
    	void setObscured(bool mode);		
    	
		
		void plugin_init();
		//void setBG();
		
	public slots:
		void slotSystemMessage(const QCString &,const QByteArray &);
		void timerEvent();  //darw screen

	private:
		HSPluginContext *plgContext;
		#if defined DEBUG || defined DEBUG_DOCKBAR
		void toLog(QString str);
		#endif
		void GetDayOf(Date &tdate,QString &strLuner);
		void drawCenter(QPainter &p);
		void drawAnalog(QPainter &p);
		void drawDigital(QPainter &p);
		void drawDate(QPainter &p);
		void drawLunar(QPainter &p);
		void drawWeek(QPainter &p);
		void drawBattery(QPainter &p);
		void drawSignal(QPainter &p);	
		void drawNotify(QPainter &p);
		void drawDockBar(QPainter &p);
		void drawFrameCover(QPainter &p);
		void drawWeather(QPainter &p);
		
		QWidget *parent;
		QRect plgnRect;
		
		bool state; //Start - true. Stop - false.
		bool bgState;
		bool timerControl;
		
		struct tm * timeinfo;
		QTimer * timer;
		QString launchUid;		
		int mTimeUP;	
		
		RES_ICON_Reader iconReader;
		
		QPixmap nowScreen;

		QString skinName;
		QString author;
		QString skinPath;
	//Frame Cover
		bool frameCoverShow;
		QPixmap frameCoverIMG;
		int frameCoverLeft;
		int frameCoverTop;
		
	//Background
		bool useDefault;
		QPixmap backIMG;
		QPixmap fmIMG;
		QPixmap centerIMG;
		//int fmImgSY;
		int softKeyHeight;
		//int softBottom;
		//QString layout;
	//Analog                
		bool analogShow;
		QPixmap analogBackIMG;
		QPixmap analogCenterIMG;
		QPixmap analogSecIMG;
		QPixmap analogMinIMG;
		QPixmap analogHourIMG;
		bool analogSecShow;
		int analogLeft;
		int analogTop;
	//Digital              ok
		bool digitalShow;
		QPixmap digitalFontIMG;
		bool digitalSecShow;
		int DHLeft;
		int DHTop;
		int HMLeft;
		int HMTop;
		int DMLeft;
		int DMTop;
		int MSLeft;
		int MSTop;
		int DSLeft;
		int DSTop;
	//Week                ok
		bool weekShow;
		QPixmap weekResIMG;
		int weekLeft;
		int weekTop;
	//[Date]             ok
		bool dateShow;
		QPixmap dateFontIMG;
		bool dateYearShow;
		int yearLeft;
		int yearTop;
		int YMLeft;
		int YMTop;
		int mouLeft;
		int mouTop;
		int MDLeft;
		int MDTop;
		int dayLeft;
		int dayTop;
	//[Lunar]           ok
		bool lunarShow;
		bool lunarYearShow;
		int lunarFontSize;
		long lunarFontColor;
		int lunarLeft;
		int lunarTop;
	//[Battery]           ok
		bool batteryShow;
		//bool batteryUseDefault;
		QPixmap batteryLevel[4];
		int batteryLeft;
		int batteryTop;
		
		int oldBatteryLevel;		
	//[Signal]              ok
		bool signalShow;
		//bool signalUseDefault;
		QPixmap signalLevel[6];
		int signalLeft;
		int signalTop;
		
		int oldSignalLevel;
	
	//[Notify]
		bool notifyShow;
		bool notifyBold;
		int notifyFontSize;
		int notifyLeft;
		//int notifyOffset;
		int notifyTop;
		QColor notifyFontColor;
		
		int notifyDestYear;
		int notifyDestMonth;
		int notifyDestDay;
		QString notifyStr;
	//[Weather]
		bool weatherShow ;
		QString weatherDataFolder ;
		QPixmap weatherPic;
		int weatherPicTop ;
		int weatherPicLeft;
		QString weatherTemp;
		int weatherTempTop;
		int weatherTempLeft;
		int weatherTempFontSize;
		long weatherTempFontColor;

		QString weatherText;
		int weatherTextTop;
		int weatherTextLeft;
		int weatherTextFontSize;
		long weatherTextFontColor;

		QString weatherPlace;
		int weatherPlaceTop; 
		int weatherPlaceLeft;
		int weatherPlaceFontSize;
		long weatherPlaceFontColor;
		int RefreshTime;
		
	//[DockBar]	
		bool dockBarShow;
		int dockBarNum;
		int dockBarBgTop; //ϱ߽
		int dockBarBgLeft; //ұ߽
		int dockBarTop[10]; //ÿһϱߵƫ
		int dockBarLeft[10]; //ÿһұߵı
		int dockBarSizeHeight[10]; //δѡ״̬µĸ
		int dockBarWidgetHeight[10]; //ѡ״̬µĸ
		int dockBarSizeWidth[10]; //δѡ״̬µĿ
		int dockBarWidgetWidth[10]; //ѡ״̬µĿ
		
		bool dockBarInfoShow; //
		int dockBarInfoFontSize[10]; 
		int dockBarInfoFontLeft[10];
		int dockBarInfoFontTop[10];
		QColor dockBarInfoFontColor[10];
		QString dockBarInfoContent[10];	
		
		QPixmap dockBarIcon[10]; //ÿһ
		QPixmap dockBarBgImg; //dock bar 
		//QPixmap dockBarCover;
		int mDockBarWidgetIndex; //ȫ¹ѡdockbarĿ
		

};

#endif


