/******************************
RokrDeskPlugin interface
by wanggjghost(εʹ)
Based on Desktop Plugin Kit - ZMyScreenPlugin by Ant-ON
Special thanks to ȪJustin.Z

www.591moto.cn
41245110@qq.com
please keep author information if you redistribute this program

**********************************/


#include "appAddDlg.h"
#include "lng.h"

extern Lng *lng;

appAddDlg :: appAddDlg(QString &title):ZPopup()
{
	isCancel = false;
	setTitle(title);
  	
	appListbox = new ZListBox ( QString ( "%I%M" ), this, 0);
	appListbox->sort(true);

	this->insertChild(appListbox);
	
	ZSoftKey *softkey = this->getSoftKey();
	softkey->setText(ZSoftKey::LEFT,  lng->tr("FT_ADD"));
    softkey->setText(ZSoftKey::RIGHT, lng->tr("FT_BACK"));
	
	softkey->setClickedSlot(ZSoftKey::RIGHT, this, SLOT( slotCancel() ));
	softkey->setClickedSlot(ZSoftKey::LEFT, this, SLOT ( slotOK() ));

	
	QTimer::singleShot(100, this, SLOT( initList() ) );
}
appAddDlg::~appAddDlg()
{
	appList.setAutoDelete(true);
	appList.clear();
}

void appAddDlg::initList()
{
	buildAppList();
	showAppList();
}

void appAddDlg::buildAppList()
{
	appList.setAutoDelete(true);
	appList.clear();
	
	creatPHApp();
	creatSDApp();
	creatSYSApp();
}
void appAddDlg::showAppList()
{
	appListbox->clear();
	append2_app_ui(appListbox,appList);
}

void appAddDlg::creatPHApp()
{
	QStringList grouplist;
	QStringList::ConstIterator p;
	
	struct appObject *obj = NULL;// = new appObject;
	
	QString path = "/ezxlocal/download/appwrite/am/InstalledDB";	
	
	if (QFile::exists(path))
	{
		qDebug("====================\n");
		int mark;// = 0;
		ZConfig cfg(path, false);
		cfg.getGroupsKeyList (grouplist);
		
		for (p = grouplist.begin(); p != grouplist.end(); ++p ) 
		{	
			mark = 0;
			obj = new appObject;
			obj->uid = *p;
			obj->name = cfg.readEntry(*p, "Name", "");//.utf8(); 
				if(obj->name != "") mark++;
			obj->type = "0";//cfg.readEntry(*p, "AppType", "");
			obj->path = cfg.readEntry(*p, "Directory", "");
				if(obj->path != "") mark++;
			obj->icon = cfg.readEntry(*p, "Icon", "");
				if(obj->icon != "") mark++;
			obj->exec = cfg.readEntry(*p, "JavaId", "");
				if(obj->exec != "") mark++;

			if(mark != 4){
				delete obj;
				continue;
			}
			
			
				appList.append(obj);				

		}
	}		
}

void appAddDlg::creatSDApp()
{
	QStringList grouplist;
	QStringList::ConstIterator p;
	
	struct appObject *obj = NULL;// = new appObject;
	
	QString path = "/mmc/mmca1/.system/java/CardRegistry";
	
	if (QFile::exists(path))
	{
		qDebug("====================\n");
		int mark;// = 0;
		ZConfig cfg(path, false);
		cfg.getGroupsKeyList (grouplist);
		
		for (p = grouplist.begin(); p != grouplist.end(); ++p ) 
		{	
			mark = 0;
			obj = new appObject;
			obj->uid = *p;
			obj->name = cfg.readEntry(*p, "Name", "");//.utf8(); 
				if(obj->name != "") mark++;
			obj->type ="0";//cfg.readEntry(*p, "AppType", "");
			obj->path = cfg.readEntry(*p, "Directory", "");
				if(obj->path != "") mark++;
			obj->icon = cfg.readEntry(*p, "Icon", "");
				if(obj->icon != "") mark++;
			obj->exec = cfg.readEntry(*p, "JavaId", "");
				if(obj->exec != "") mark++;

			if(mark != 4){
				delete obj;
				continue;
			}

				appList.append(obj);				

		}
	}		
}

void appAddDlg::creatSYSApp()
{
	QStringList grouplist;
	QStringList::ConstIterator p;
	
	struct appObject *obj = NULL;// = new appObject;
	
	QString uidStr; // tmp uid string that contains all uids in each "item =" in menutree
	QStringList menuList;
	QStringList uidList;
	int mark;
	
	ZConfig treeCfg("/ezxlocal/download/appwrite/am/UserMenuTree", false);
	ZConfig regCfg("/usr/data_resource/preloadapps/SysRegistry", false);
	
	treeCfg.getGroupsKeyList (menuList);	

	for (p = menuList.begin(); p != menuList.end(); ++p ) 
	{	
        uidStr = treeCfg.readEntry(*p, "Items", "");  
		uidList += QStringList::split(";", uidStr);
    }
	
    for (p = uidList.begin(); p != uidList.end(); ++p)
	{
		mark = 0;
		obj = new appObject;
		obj->uid = *p;
	    //std::cout<<"uid = "<<obj->uid<<std::endl;
		obj->name = regCfg.readEntry(*p, "Name", ""); 
		    if (obj->name != "") mark++;
		obj->type = "0";//regCfg.readEntry(*p, "AppType", "");
		obj->icon = regCfg.readEntry(*p, "BigIcon", "");
		    if (obj->icon != "") mark++;
		obj->exec = regCfg.readEntry(*p, "AppID", "");
		    if (obj->exec != "") mark ++;
		obj->path = regCfg.readEntry(*p, "Directory", "");

		if (mark != 3)
		{
		    delete obj;
		    continue;
		}
        appList.append(obj);		
	}			
}

void appAddDlg::append2_app_ui(ZListBox *target, QList<struct appObject> appList)
{
	int itemIndex = 0;
	target->setItemType(QString("%I%M"));	

	struct appObject *tmpObj = appList.first();
	ZSettingItem *pItem = NULL;
	QString iconPath;
    QString text;
    QPixmap icon;
    while (tmpObj!=NULL)
    {
	    pItem = new ZSettingItem(target);
		text = tmpObj->name;
		iconPath = tmpObj->path+"/"+tmpObj->icon;	
	
	    if (QFile::exists(iconPath)) icon = QPixmap(iconPath);
		else icon = iconReader.getIcon(tmpObj->icon);

	    QImage img = icon.convertToImage();
	    img = img.smoothScale(24, 24);
	    icon.convertFromImage(img);
		
        pItem->appendSubItem(itemIndex+1, text, false, SETTINGITEM_REGION_A);

	    pItem->setPixmap(itemIndex, icon);
	    target->insertItem(pItem);
	    tmpObj = appList.next();
    }
	target->setCurrentItem(0);
}


void appAddDlg::slotOK()
{	
	struct appObject *obj = NULL;
	int index =appListbox->currentItem();
	if (index != -1) 
		obj = appList.at(index);
	else
		return;	
	
	name = obj->name;
	//uid = obj->uid;

	//if ( obj->type.toInt() != 0) 

		mExec = obj->uid;
	//else
		//mExec = obj->exec;
	
	type = obj->type;
	QString iconPath = obj->path+"/"+obj->icon;	
	if (QFile::exists(iconPath)) icon = iconPath;
	else icon = obj->icon;
	
	isCancel = false;
	reject();
}


void appAddDlg::slotCancel()
{
	isCancel = true;
	reject();
}


