/******************************
RokrDeskPlugin interface
by wanggjghost(泪の单翼天使)
Based on Desktop Plugin Kit - ZMyScreenPlugin by Ant-ON
Special thanks to 夏日清泉（Justin.Z）

www.591moto.cn
41245110@qq.com
please keep author information if you redistribute this program

**********************************/

#include <ZConfig.h>
#include <ZListBoxItem.h>
#include <ZMessageDlg.h>

#include <qdir.h>
#include <qtextcodec.h>
#include <qcopchannel_qws.h>

#include <iostream>

#include "dockDlg.h"
#include "skinDlg.h"
#include "lng.h"
#include "appAddDlg.h"

extern Lng *lng;

using namespace std;

dockDlg::dockDlg() :ZPopup()
{
	mDdir = getAppDir();
	isCancel = false;
	
	this->setTitle(lng->tr("FT_DOCKBAR"));
	//this->setTitleIcon(iconReader.getIcon("fm_folder_small.bmp"));

	QRect rect=ZGlobal::getContentR();
		
    listBox = new ZListBox("%I%M",this);	
	listBox->enableMarquee(ZListBox::LISTITEM_REGION_A, true);
	listBox->enableMarquee(ZListBox::LISTITEM_REGION_B, true);		
	this->insertChild(listBox);
	
	softKey = this->getSoftKey();
	//softKey->setText(ZSoftKey::LEFT,  lng->tr("FT_PREVIEW"));
    softKey->setText(ZSoftKey::RIGHT, lng->tr("FT_BACK"));
	
	softKey->setClickedSlot(ZSoftKey::LEFT, this ,SLOT( slotQuit() ));
	softKey->setClickedSlot(ZSoftKey::RIGHT, this ,SLOT( slotQuit() ));

	initList();
	
	connect(listBox, SIGNAL( selected ( int ) ), this, SLOT(slotItemClicked(int)));		
}

dockDlg::~dockDlg()
{
}

void dockDlg::initList()
{
	printf("build list item \n");
	
	const char *lngList[11] = {"FT_1", "FT_2", "FT_3", "FT_4", "FT_5", "FT_6", "FT_7", "FT_8", "FT_9", "FT_10"};
	for (int i=0; i<10; i++)
    {
        listBoxItem[i] = new ZListBoxItem(listBox);
		listBoxItem[i]->appendSubItem(1, lng->tr("FT_DOCKBAR")+lng->tr(lngList[i]) );
        listBoxItem[i]->setPixmap(0, QPixmap(mDdir+"/img/dock.png"));
		listBox->insertItem(listBoxItem[i]);	
    }	
}
void dockDlg::slotQuit()
{
	reject();
}
void dockDlg::slotItemClicked(int index)
{
	printf("click index %d\n", index);
	
	const char *lngList[11] = {"FT_1", "FT_2", "FT_3", "FT_4", "FT_5", "FT_6", "FT_7", "FT_8", "FT_9", "FT_10"};
	
	QString title = lng->tr("FT_DOCKBAR")+lng->tr(lngList[index]);
	appAddDlg *dlg = new appAddDlg( title );
	dlg->exec();
	QString exec = dlg->mExec;
	QString type = dlg->type;
	QString icon = dlg->icon;
	QString name = dlg->name;
	bool isCancel = dlg->isCancel;
	delete dlg;
	dlg = NULL;
	if( !isCancel )
	{
		ZConfig mCfg(DESK_MAIN_CFG);
		
		mCfg.writeEntry("DockBar", QString("Icon%1").arg(index), icon);
		mCfg.writeEntry("DockBar", QString("Type%1").arg(index), type);
		mCfg.writeEntry("DockBar", QString("Exec%1").arg(index), exec);	
		mCfg.writeEntry("DockBar", QString("Name%1").arg(index), name);		
		
		mCfg.flush();	

		QCopChannel::send(ROKR_CHANNEL,"Reload()");	
	}
}




