/******************************
RokrDeskPlugin interface
by wanggjghost(泪の单翼天使)
Based on Desktop Plugin Kit - ZMyScreenPlugin by Ant-ON
Special thanks to 夏日清泉（Justin.Z）

www.591moto.cn
41245110@qq.com
please keep author information if you redistribute this program

**********************************/

#include <ZGlobal.h>
#include <ZMessageDlg.h>
#include <ZConfig.h>
#include <ZSingleSelectDlg.h>

#include <qtextcodec.h>
#include <qcopchannel_qws.h>
#include <qfile.h>

#include <iostream>

#include "lockUI.h"
#include "skinDlg.h"
#include "lng.h"
#include "dockDlg.h"

extern Lng *lng;

using namespace std;


LockUI::LockUI(QWidget* parent, const char*, WFlags)
	: ZKbMainWidget(ZHeader::MAINDISPLAY_HEADER, 0, "ui", WType_TopLevel)
	//:ZPopup(ZPopup::DIALOG, parent)
{
	isRun = false;
    isAutorun = false;
	mDdir = getAppDir();
	mCfg = new ZConfig(DESK_MAIN_CFG, false);
	
	//this->setTitle(lng->tr(TITLE));
	this->setAppTitle(lng->tr(TITLE));
	//this->setTitleIcon(QPixmap(mDdir+"/img/title.png"));
	this->setMainWidgetTitleIcon(QPixmap(mDdir+"/img/title.png"));
	
	QRect rect=ZGlobal::getContentR();
		
    listBox = new ZListBox("%I%M",this);
	listBox->enableMarquee(ZListBox::LISTITEM_REGION_A, true);
	listBox->enableMarquee(ZListBox::LISTITEM_REGION_B, true);	
	//this->insertChild(listBox);
	//this->setContentWidget(listBox);
	QVBoxLayout *layout=getVBoxLayout();
	layout->addWidget(listBox);


	buildListItem();
	
	printf("option menu \n");
	menu = new ZOptionsMenu(rect, this, 0, 0, (ZSkinService::WidgetClsID)55);
	//menu->insertItem(lng->tr("快捷程序"), sub, NULL, true, 0, 0, false, false, false );
	menu->insertItem(lng->tr("FT_DOCKBAR"), NULL, this, SLOT( slotDock() ), true, false, false, 0, 0);	
	menu->insertItem(lng->tr("FT_WEATHER"), NULL, this, SLOT( slotWeather() ), true, false, false, 3, 3);
	menu->insertItem(lng->tr("FT_EVENT"), NULL, this, SLOT( slotNote() ), true, false, false, 1, 1);	
	//will make some "bugs"
	//menu->insertItem(lng->tr("刷新频率"), NULL, this, SLOT( slotFrec() ), true, false, false, 2, 2);		
	menu->insertItem(lng->tr("FT_ABOUT"), NULL, this, SLOT( slotAbout() ), true, false, false, 3, 3);
	
    printf("soft key\n");
	
	//softKey = this->getSoftKey();
	softKey = new ZSoftKey("CST_2A", this, this);
	this->setSoftKey(softKey);
	softKey->setText(ZSoftKey::LEFT,  lng->tr("FT_OPTION"));
    softKey->setText(ZSoftKey::RIGHT, lng->tr("FT_BACK"));
   // this->setCLISoftKey(softKey);
	//softKey->setClickedSlot(ZSoftKey::LEFT, this ,SLOT(slotAbout()));
	softKey->setOptMenu(ZSoftKey::LEFT, menu);
	softKey->setClickedSlot(ZSoftKey::RIGHT, this ,SLOT(slotQuit()));

	printf("connect\n");
	connect(listBox, SIGNAL( selected ( int ) ), this, SLOT(slotItemClicked(int)));
}	
LockUI::~LockUI()
{
	delete mCfg;
	mCfg = NULL;
}
void LockUI::slotWeather()
{
	system("(exec "+mDdir+"/wconfig.sh)&");

}
void LockUI::getThemeInfo(QString &info)
{
	printf("get theme info\n");
	
	ZConfig skinCfg(DESK_MAIN_CFG);
	QString cSkin = skinCfg.readEntry("Main", "Skin", "");
	cout<<"skin "<<cSkin<<endl;
	
	ZConfig cfg(mDdir+"/skin/"+cSkin+"/skin.cfg");
	cout<<"skin cfg "<<mDdir+"/skin/"+cSkin+"/skin.cfg"<<endl;
	
	QString a = cfg.readEntry("General", "SkinName", "");
	QString b = cfg.readEntry("General", "Author", "");
	
	info = lng->tr("FT_THEME")+a+ctr("；")+lng->tr("FT_AUTHOR")+b;
	
	cout<<a<<b<<endl;
}

void LockUI::buildListItem()
{
	printf("build list item \n");
	
	for (int i=0; i<4; i++)
    {
        listBoxItem[i] = new ZListBoxItem(listBox);
		listBox->insertItem(listBoxItem[i]);
    }	
	
	getThemeInfo(themeInfo);
	
	printf("after theme info\n");
	isRun = QCopChannel::isRegistered(ROKR_CHANNEL);
	
    if(QFile::exists(AUTORUN_FILE)) 
	    isAutorun = true;
    else 
	    isAutorun = false;
	
	if(isRun)
		onoffString = lng->tr("FT_CUR_STATE_ON");
	else
		onoffString = lng->tr("FT_CUR_STATE_OFF");
		
	if(isAutorun)
        autorunString = lng->tr("FT_AUTORUN_STATE_ON");
	else
	    autorunString = lng->tr("FT_AUTORUN_STATE_OFF");
	
	/*************************************************/
	printf("list box item\n");
    
	listBoxItem[0]->appendSubItem(1, lng->tr("FT_RUNNING_STATE"));
	listBoxItem[0]->appendSubItem(1, onoffString);
	if(isRun)
        listBoxItem[0]->setPixmap(0, QPixmap(mDdir+"/img/status.png"));
	else
        listBoxItem[0]->setPixmap(0, QPixmap(mDdir+"/img/off.png"));		
	
	listBoxItem[1]->appendSubItem(1, lng->tr("FT_AUTORUN_STATE"));
    listBoxItem[1]->appendSubItem(1, autorunString);
	if(isAutorun)
        listBoxItem[1]->setPixmap(0, QPixmap(mDdir+"/img/autorun.png"));
	else
	    listBoxItem[1]->setPixmap(0, QPixmap(mDdir+"/img/off.png"));
		
	listBoxItem[2]->appendSubItem(1, lng->tr("FT_REFRESH_SCREEN"));	
	listBoxItem[2]->appendSubItem(1, lng->tr("FT_FORCE_REFRESH_SCREEN"));
    listBoxItem[2]->setPixmap(0, QPixmap(mDdir+"/img/refresh.png"));	
	
	
	listBoxItem[3]->appendSubItem(1, lng->tr("FT_CHG_THEME"));	
	listBoxItem[3]->appendSubItem(1, themeInfo);
    listBoxItem[3]->setPixmap(0, QPixmap(mDdir+"/img/theme.png"));
} 

void LockUI::slotItemClicked(int index)
{
    printf("itme cliked %d\n", index);
	if(index == 0)
	{
	    if(isRun)
		{
			printf("===== stop\n");
			//HSSyncStateAPI::HS_endsync();
			//QCopChannel::send(ROKR_CHANNEL,"Quit()");
			system( QString("%1/%2").arg( mDdir ).arg(STOP_FILE) );
			listBoxItem[0]->setSubItem(1,1, lng->tr("FT_CUR_STATE_OFF"));
			listBoxItem[0]->setPixmap(0, QPixmap(mDdir+"/img/off.png"));
			isRun = !isRun;
			slotQuit();

		}
		else
		{
			if( !QCopChannel::isRegistered(ROKR_CHANNEL) )
			{
				printf("===== start\n");
				
				//HSSyncStateAPI::HS_beginsync();
				//system(QString("exec %1/lock_daemon &").arg(mDdir));
				system( QString("%1/%2").arg( mDdir ).arg(START_FILE) );
			    listBoxItem[0]->setSubItem(1,1, lng->tr("FT_CUR_STATE_ON"));
			    listBoxItem[0]->setPixmap(0, QPixmap(mDdir+"/img/status.png"));					
				isRun = !isRun;
				slotQuit();
			}
		}
	}
	if(index == 1)
	{
	    if(isAutorun)
		{
			system( QString("rm -f %1").arg( QString(AUTORUN_FILE) ) );
			listBoxItem[1]->setSubItem(1,1,lng->tr("FT_AUTORUN_STATE_OFF"));
            listBoxItem[1]->setPixmap(0,QPixmap(mDdir+"/img/off.png"));		
		}
		else
		{
			system( QString("cp -f %1/load.sh %2").arg( mDdir ).arg( QString(AUTORUN_FILE) ) );
			listBoxItem[1]->setSubItem(1,1,lng->tr("FT_AUTORUN_STATE_ON"));
            listBoxItem[1]->setPixmap(0,QPixmap(mDdir+"/img/autorun.png"));
		}
	    isAutorun = !isAutorun;	
	}
	if(index == 2)
	{
		//ZMessageDlg *dlg = new ZMessageDlg(lng->tr("FT_REFRESH_SCREEN"), lng->tr("FT_CONFIRM_REFRESH"), (ZMessageDlg::MessageDlgType)1);
		//int ret = dlg->exec();
		//if(ret != 1)
		//	return;
		//system( QString("exec %1/refresh.sh &").arg( mDdir ) );
		//system("kill `pidof phone`");
		//slotQuit();	
		/*ZSingleSelectDlg *dlg = new ZSingleSelectDlg( lng->tr("自动刷新") , lng->tr("请选择") );
		QStringList strlist;
		strlist += lng->tr("关闭自动刷新");
		strlist += lng->tr("开启自动刷新");
		dlg->addItemsList(strlist);
		dlg->exec();
		int ret = dlg->getCheckedItemIndex();
		printf("===== ret %d\n",ret);
		delete dlg;
		dlg = NULL;
		if(ret!=0 && ret!=1)  return;
		if(ret == 0) {
			if( QCopChannel::send(ROKR_CHANNEL,"Stop()") )
				printf("===== channel ok\n");
		} else {
			if( QCopChannel::send(ROKR_CHANNEL,"Start()") )
				printf("===== channel error \n");			
		}*/
		ZSingleSelectDlg *dlg = new ZSingleSelectDlg( lng->tr("FT_REFRESH_SCREEN") , "" );
		QStringList strlist;
		strlist += lng->tr("FT_REFRESH_WALLPAPER");
		strlist += lng->tr("FT_REBOOT_APP");
		dlg->addItemsList(strlist);
		int ret;
		if(dlg->exec() == ZPopup::Accepted) {
			ret = dlg->getCheckedItemIndex();
			delete dlg;			
		} else {
			delete dlg;
			return;		
		}
		switch (ret) {
			case 0 :
				if( QCopChannel::send(ROKR_CHANNEL,"Reload()") )
					printf("===== channel ok\n");
				break;
			case 1 :
				system("kill `pidof phone`");
				slotQuit();	
				break;
			default :
				break;
		}
	}
	if(index == 3)
	{
		skinDlg *dlg = new skinDlg();
		dlg->exec();
		QString str = dlg->curSkin;
		bool isCancel = dlg->isCancel;
		delete dlg;
		dlg = NULL;
		cout<<"str "<<str<<endl;

		if(!isCancel)
		{
			mCfg->writeEntry("Main", "Skin", str );
			mCfg->flush();
			getThemeInfo(themeInfo);
			listBoxItem[3]->setSubItem(1,1, themeInfo);
			
			QCopChannel::send(ROKR_CHANNEL,"Reload()");
		}
	}
}

void LockUI::slotQuit()
{
	qApp->quit();
	//reject();
}

void LockUI::slotAbout()
{
	ZMessageDlg *dlg = new ZMessageDlg(lng->tr("FT_ABOUT"), ctr(ABOUT_TEXT), (ZMessageDlg::MessageDlgType)2);
	dlg->exec();
	delete dlg;	
	//ZPopup::accept();
}
void LockUI::slotNote()
{
	dateDlg *dlg = new dateDlg();
	dlg->exec();
	QDate date = dlg->getDate();
	QString str = dlg->getString();
	bool isCancel = dlg->isCancel;
	delete dlg;
	dlg = NULL;
	
	if( !isCancel )
	{
		mCfg->writeEntry("Notify", "Year", date.year() );
		mCfg->writeEntry("Notify", "Month", date.month() );
		mCfg->writeEntry("Notify", "Day", date.day() );
		mCfg->writeEntry("Notify", "Info", str );
		mCfg->flush();
		
		QCopChannel::send(ROKR_CHANNEL,"Reload()");
	}
}
void LockUI::slotFrec()
{
	int ret = mCfg->readNumEntry("Main", "Timeout", 1000)/1000;
	QString title = lng->tr("FT_REFRESH_TIME");
	QString text =  lng->tr("单位为“秒”");
	showSliderDlg *dlg = new showSliderDlg(title, text, 1, ret, 30);
	dlg->exec();
	ret=dlg->ret;
	bool isCancel=dlg->isCancel;
	delete dlg;
	dlg = NULL;
	if( !isCancel )
	{
		mCfg->writeEntry("Main", "Timeout", ret*1000);
		mCfg->flush();
		
		QCopChannel::send(ROKR_CHANNEL,"Reload()");
	}
}
void LockUI::slotDock()
{
	dockDlg * dlg = new dockDlg();
	dlg->exec();
	delete dlg;
	dlg = NULL;
}
