/******************************
RokrDeskPlugin interface
by wanggjghost(泪の单翼天使)
Based on Desktop Plugin Kit - ZMyScreenPlugin by Ant-ON
Special thanks to 夏日清泉（Justin.Z）

www.591moto.cn
41245110@qq.com
please keep author information if you redistribute this program

**********************************/

#include "showPreview.h"
#include "tool.h"
#include "lng.h"

extern Lng *lng;

using namespace std;

extern "C" int UTIL_GetBatteryLevel(); 
extern "C" int UTIL_GetSignalQuality(); 
//extern "C" bool UTIL_GetPhoneInCall(); 

// i don't know how to translate in English in line 410 --!

showPreview::showPreview(QString &skinDir):MyBaseDlg()
{
	mSkinDir = skinDir;
	
	cout<<"====== mSkinDir "<<mSkinDir<<"======="<<endl;
	
	setMainWidgetTitle( lng->tr("FT_THEME_PREVIEW") );
	
	//this->setFullScreenMode(true);
	
	plugin_init();
	
	ZSoftKey *softKey = new ZSoftKey ( NULL, this, this );
	//softKey->setText(ZSoftKey::LEFT, lng->tr("确定"));
    softKey->setText(ZSoftKey::RIGHT, lng->tr("FT_BACK"));	
	softKey->setClickedSlot(ZSoftKey::RIGHT, this, SLOT ( slotQuit() ));
	softKey->setClickedSlot(ZSoftKey::LEFT, this, SLOT ( slotQuit() ));
	//setCSTWidget(softKey);
}
	
showPreview::~showPreview()
{

}
void showPreview::slotQuit()
{
	MyBaseDlg::reject();
}
void showPreview::plugin_init()
{
	oldBatteryLevel = -1;
	oldSignalLevel = -1;
	mDockBarWidgetIndex = -1; //dockbar初始化为不选中
	
	//QString skinName;
	QString skinPath;
	QString skinCfg;

	ZConfig main( DESK_MAIN_CFG, false);
	//skinName = main.readEntry("Main", "Skin", "default");

	skinPath = QString("%1/%2/").arg( QString(DESK_SKIN_PATH) ).arg(mSkinDir);//QString(DESK_SKIN_PATH)+skinName+"/";
	skinCfg = skinPath+"skin.cfg";
	
	cout<<"======= skin cfg "<<skinCfg<<"======="<<endl;

	ZConfig config(skinCfg, false);

	//get wall paper
	#ifdef VE66
	ZConfig ezx_theme(EZX_SYSTEM, false);
	QString curSkin = ezx_theme.readEntry("SYS_DISPLAY_SET", "Skin", "");
	#else
	ZConfig ezx_theme(EZX_THEME, false);
	QString curSkin = ezx_theme.readEntry("THEME_GROUP_LOG", "CurrentSkin", "");
	#endif
	
	//fix for wall paper zoom
	QString softkeyFile = QString("%1/homescreen_p.ini").arg(curSkin);
	if( ! QFile::exists( softkeyFile ) )
		softkeyFile = QString("%1/common.ini").arg(curSkin);
	ZConfig softkeyCfg(softkeyFile);
	softKeyHeight = softkeyCfg.readNumEntry("ZSoftKey_Right", "Padding_Bottom", 3);
	softKeyHeight += softkeyCfg.readNumEntry("ZSoftKey_Right", "Padding_Top", 3);
	
	// fix for dcf wall paper and big wall paper
	#ifdef VE66
	QString wallPaper = ezx_theme.readEntry("SYS_DISPLAY_SET", "Wallpaper", "");
	#else
	ZConfig wall( ezx_theme.readEntry("THEME_GROUP_LOG", "CurrentTheme", "") );	
	QString wallPaper = wall.readEntry("THEME_CONFIG_TABLE","WallPaper", "");
	#endif
	if(wallPaper.endsWith( QString(".dcf") )) {
		fmIMG.load(skinPath+config.readEntry("Background","MidIMG", ""));	
	} else {	
		fmIMG.load(wallPaper);
		#ifdef VE66
		if(fmIMG.height() != 320 || fmIMG.width() != 240) {
		#else
		if(fmIMG.height() != 240 || fmIMG.width() != 320) {
		#endif
			QImage img = fmIMG.convertToImage();
			#ifdef VE66
			img = img.smoothScale(240, 320);
			#else
			img = img.smoothScale(320, 240);
			#endif
			fmIMG.convertFromImage(img);	
		}
	}
	
	centerIMG.load(skinPath+config.readEntry("Background","MidIMG", ""));	
		
	//Analog
	analogShow=config.readBoolEntry("Analog", "Show", false);
	if(analogShow) 	{
		analogBackIMG.load(skinPath+config.readEntry("Analog", "BackIMG", ""));
		analogCenterIMG.load(skinPath+config.readEntry("Analog", "CenterIMG", ""));
		
		analogMinIMG.load(skinPath+config.readEntry("Analog", "MinIMG", ""));
		analogHourIMG.load(skinPath+config.readEntry("Analog", "HourIMG", ""));
		analogSecShow=config.readBoolEntry("Analog", "SecShow", "");
		if(analogSecShow)
			analogSecIMG.load(skinPath+config.readEntry("Analog", "SecIMG", ""));
		
		analogLeft=config.readNumEntry("Analog", "Left", 0);
		analogTop=config.readNumEntry("Analog", "Top", 0);
	}
	//Digital
	digitalShow=config.readBoolEntry("Digital","Show", false);
	if(digitalShow) {
		digitalFontIMG.load(skinPath+config.readEntry("Digital", "FontIMG", ""));
		digitalSecShow=config.readBoolEntry("Digital", "SecShow", false);
		
		DHLeft=config.readNumEntry("Digital", "HourLeft", 0);
		DHTop=config.readNumEntry("Digital", "HourTop", 0);
		HMLeft=config.readNumEntry("Digital", "Colon0Left", 0);
		HMTop=config.readNumEntry("Digital", "colon0Top", 0);
		DMLeft=config.readNumEntry("Digital", "MinLeft", 0);
		DMTop=config.readNumEntry("Digital", "MinTop", 0);
		MSLeft=config.readNumEntry("Digital", "Colon1Left", 0);
		MSTop=config.readNumEntry("Digital", "colon1Top", 0);
		DSLeft=config.readNumEntry("Digital", "SecLeft", 0);
		DSTop=config.readNumEntry("Digital", "SecTop", 0);
	}	
	//Week
	weekShow=config.readBoolEntry("Week", "Show", false);
	if(weekShow) {
		weekResIMG.load(skinPath+config.readEntry("Week", "ResIMG", ""));
		weekLeft=config.readNumEntry("Week", "Left", 0);
		weekTop=config.readNumEntry("Week", "Top", 0);
	}	
	//[Date]
	dateShow=config.readBoolEntry("Date", "Show" , false);
	if(dateShow) {
		dateFontIMG.load(skinPath+config.readEntry("Date", "FontIMG", ""));
		dateYearShow=config.readBoolEntry("Date","YearShow",false);
		yearLeft=config.readNumEntry("Date","YearLeft", 0);
		yearTop=config.readNumEntry("Date","YearTop", 0);
		YMLeft=config.readNumEntry("Date","YMLeft", 0);
		YMTop=config.readNumEntry("Date","YMTop", 0);
		mouLeft=config.readNumEntry("Date","MouLeft", 0);
		mouTop=config.readNumEntry("Date","MouTop", 0);
		MDLeft=config.readNumEntry("Date","MDLeft", 0);
		MDTop=config.readNumEntry("Date","MDTop", 0);
		dayLeft=config.readNumEntry("Date","DayLeft", 0);
		dayTop=config.readNumEntry("Date","DayTop", 0);
	}
	//[Lunar]
	lunarShow=config.readBoolEntry("Lunar","Show", false);
	if(lunarShow) {
		lunarFontSize=config.readNumEntry("Lunar","FontSize",0);
		lunarFontColor=config.readEntry("Lunar","FontColor","").toLong();
		lunarLeft=config.readNumEntry("Lunar","Left",0);
		lunarTop=config.readNumEntry("Lunar","Top",0);
	}
	//[Battery]
	batteryShow=config.readBoolEntry("Battery","Show",false);
	if(batteryShow) {
		batteryLeft=config.readNumEntry("Battery","Left", 0);
		batteryTop=config.readNumEntry("Battery","Top", 0);	
		batteryLevel[0].load( skinPath+config.readEntry("Battery","Level0","") );
		batteryLevel[1].load( skinPath+config.readEntry("Battery","Level1","") );
		batteryLevel[2].load( skinPath+config.readEntry("Battery","Level2","") );
		batteryLevel[3].load( skinPath+config.readEntry("Battery","Level3","") );
	}
	//[Signal]
	signalShow=config.readBoolEntry("Signal","Show", false);
	if(signalShow)	{
		signalLeft=config.readNumEntry("Signal","Left",0);
		signalTop=config.readNumEntry("Signal","Top",0);
		signalLevel[0].load( skinPath+config.readEntry("Signal","Level0","") );
		signalLevel[1].load( skinPath+config.readEntry("Signal","Level1","") );
		signalLevel[2].load( skinPath+config.readEntry("Signal","Level2","") );
		signalLevel[3].load( skinPath+config.readEntry("Signal","Level3","") );
		signalLevel[4].load( skinPath+config.readEntry("Signal","Level4","") );
		signalLevel[5].load( skinPath+config.readEntry("Signal","Level5","") );
	}
	//[Notify]
	notifyShow = config.readBoolEntry("Notify","Show", false);
	if(notifyShow) {
		notifyBold=config.readBoolEntry("Notify","Bold",false);
		notifyFontSize=config.readNumEntry("Notify","FontSize",0);
		notifyLeft=config.readNumEntry("Notify","Left",0);
		notifyTop=config.readNumEntry("Notify","Top",0);
		notifyFontColor=config.readEntry("Notify","FontColor","").toLong();	
		//notifyOffset = 0;
		notifyDestYear = main.readUIntEntry("Notify", "Year", 1987);
		notifyDestMonth = main.readUIntEntry("Notify", "Month", 4);
		if(notifyDestMonth>12 && notifyDestMonth<1)
			notifyDestMonth = 4;			
		notifyDestDay = main.readUIntEntry("Notify", "Day", 6);
		if(notifyDestDay>31 && notifyDestDay<1)
			notifyDestDay = 6;
		notifyStr = main.readEntry("Notify", "Info", "泪の单翼天使的出生日期^^");
	}
	//[DockBar]	
	dockBarShow = config.readBoolEntry("DockBar","Show", false);
	if(dockBarShow){
		dockBarBgImg.load(skinPath+config.readEntry("DockBar", "BGIMG", ""));
		dockBarBgTop = config.readNumEntry("DockBar","BGTop",0);
		dockBarBgLeft = config.readNumEntry("DockBar","BGLeft",0);
		dockBarNum = config.readNumEntry("DockBar","Num",1);
		for(int i=0;i<dockBarNum;i++){
			dockBarTop[i] = config.readNumEntry("DockBar",QString("Top%1").arg(i),1);
			dockBarLeft[i] = config.readNumEntry("DockBar",QString("Left%1").arg(i),1);
			dockBarSizeHeight[i] = config.readNumEntry("DockBar",QString("SizeHeight%1").arg(i),1);
			dockBarWidgetHeight[i] = config.readNumEntry("DockBar",QString("WidgetHeight%1").arg(i),1);
			dockBarSizeWidth[i] = config.readNumEntry("DockBar",QString("SizeWidth%1").arg(i),1);
			dockBarWidgetWidth[i] = config.readNumEntry("DockBar",QString("WidgetWidth%1").arg(i),1);
			QString tmp = main.readEntry("DockBar", QString("Icon%1").arg(i), skinPath+"dock.png");
			if(	QFile::exists(tmp) ) 
				dockBarIcon[i].load( tmp );
			else 
				dockBarIcon[i] = iconReader.getIcon(tmp);
		}	
	}
}
void showPreview::paintEvent( QPaintEvent *pe)
{
	nowScreen = fmIMG;
	
	#ifdef VE66
	QRect ur(0,0,320,240);	
	#else
	QRect ur(0,0,240,320);	//用户可见区域
	#endif
	ur=pe->rect();
	
	QPainter p(&nowScreen);
	p.begin(&nowScreen);
	
	drawCenter(p);
	
	if(analogShow)
		drawAnalog(p);
	if(digitalShow)
		drawDigital(p);
	if(dateShow)
		drawDate(p);
	if(lunarShow)
		drawLunar(p);
	if(weekShow)
		drawWeek(p);
	if(batteryShow)
		drawBattery(p);
	if(signalShow)	
		drawSignal(p);
	if(notifyShow)
		drawNotify(p);
	if(dockBarShow)
		drawDockBar(p);

	p.end();
	
	//bitBlt(parent,0,0,&nowScreen,0); 
	//setWFlags(getWFlags() | Qt::WRepaintNoErase);	//设置无背景色*****
	bitBlt(this, 0, 0, &nowScreen, 0);//, 0, 240, 320);//将内存中画布复制到屏幕
	QWidget::paintEvent( pe);
}
//void showPreview::setBG()
//{
//	QWallpaper::setSysWallpaper(&fmIMG);
//}

void showPreview::drawCenter(QPainter &p)
{
	p.drawPixmap(0,0, centerIMG);
}
void showPreview::drawAnalog(QPainter &p)
{
	p.drawPixmap(analogLeft,analogTop,analogBackIMG);
	
	time_t rawtime;
	time ( &rawtime );
	timeinfo = localtime ( &rawtime );
	
	QWMatrix h;                         // transformation matrix

	h.rotate( (float)(timeinfo->tm_hour%12)*30+(float)(timeinfo->tm_min%60)*0.25);
	//printf("\nrotate:%f",(float)(timeinfo->tm_hour%12)*15.0+(float)(timeinfo->tm_min%60)*0.25);
	QPixmap hour = analogHourIMG.xForm( h );  
	p.drawPixmap((analogBackIMG.width()-hour.width())/2+analogLeft,(analogBackIMG.height()-hour.height())/2+analogTop,hour);

	QWMatrix m;                         // transformation matrix

	m.rotate( (float)(timeinfo->tm_min%60)*6.0);
	
	QPixmap min = analogMinIMG.xForm( m );  
	p.drawPixmap((analogBackIMG.width()-min.width())/2+analogLeft,(analogBackIMG.height()-min.height())/2+analogTop,min);

	if(analogSecShow)
	{
		QWMatrix s;                         // transformation matrix

		s.rotate( (float)(timeinfo->tm_sec%60)*6.0);
	
		QPixmap sec = analogSecIMG.xForm( s );  
		p.drawPixmap((analogBackIMG.width()-sec.width())/2+analogLeft,(analogBackIMG.height()-sec.height())/2+analogTop,sec);
	}
}
void showPreview::drawDigital(QPainter &p)
{
	//printf("\ndraw digital\n");
	time_t rawtime;
	time ( &rawtime );
	timeinfo = localtime ( &rawtime );
		
	p.drawPixmap(DHLeft,DHTop,digitalFontIMG,0,timeinfo->tm_hour/10*digitalFontIMG.height()/11,digitalFontIMG.width(),digitalFontIMG.height()/11);
		
	p.drawPixmap(DHLeft+digitalFontIMG.width(),DHTop,digitalFontIMG,0,timeinfo->tm_hour%10*digitalFontIMG.height()/11,digitalFontIMG.width(),digitalFontIMG.height()/11);
	
	p.drawPixmap(HMLeft,HMTop,digitalFontIMG,0,10*digitalFontIMG.height()/11,digitalFontIMG.width(),digitalFontIMG.height()/11);
	
	p.drawPixmap(DMLeft,DMTop,digitalFontIMG,0,timeinfo->tm_min/10*digitalFontIMG.height()/11,digitalFontIMG.width(),digitalFontIMG.height()/11);
		
	p.drawPixmap(DMLeft+digitalFontIMG.width(),DMTop,digitalFontIMG,0,timeinfo->tm_min%10*digitalFontIMG.height()/11,digitalFontIMG.width(),digitalFontIMG.height()/11);
	
	if(digitalSecShow)
	{
		p.drawPixmap(MSLeft,MSTop,digitalFontIMG,0,10*digitalFontIMG.height()/11,digitalFontIMG.width(),digitalFontIMG.height()/11);
	
		p.drawPixmap(DSLeft,DSTop,digitalFontIMG,0,timeinfo->tm_sec/10*digitalFontIMG.height()/11,digitalFontIMG.width(),digitalFontIMG.height()/11);
		
		p.drawPixmap(DSLeft+digitalFontIMG.width(),DSTop,digitalFontIMG,0,timeinfo->tm_sec%10*digitalFontIMG.height()/11,digitalFontIMG.width(),digitalFontIMG.height()/11);
	}	
}
void showPreview::drawDate(QPainter &p)
{
	time_t rawtime;
	time ( &rawtime );
	timeinfo = localtime ( &rawtime );
	Date tdate;
	tdate.year=timeinfo->tm_year+1900;
	tdate.month=timeinfo->tm_mon+1;
	tdate.day=timeinfo->tm_mday;
	
	int yearshow=0;

	if(dateYearShow)
	{
		p.drawPixmap(yearLeft,yearTop,dateFontIMG,0,tdate.year/1000*dateFontIMG.height()/11,dateFontIMG.width(),dateFontIMG.height()/11);
		p.drawPixmap(yearLeft+dateFontIMG.width(),yearTop,dateFontIMG,0,tdate.year%1000/100*dateFontIMG.height()/11,dateFontIMG.width(),dateFontIMG.height()/11);
		p.drawPixmap(yearLeft+dateFontIMG.width()*2,yearTop,dateFontIMG,0,tdate.year%100/10*dateFontIMG.height()/11,dateFontIMG.width(),dateFontIMG.height()/11);
		p.drawPixmap(yearLeft+dateFontIMG.width()*3,yearTop,dateFontIMG,0,tdate.year%10*dateFontIMG.height()/11,dateFontIMG.width(),dateFontIMG.height()/11);
		
		p.drawPixmap(YMLeft,YMTop,dateFontIMG,0,10*dateFontIMG.height()/11,dateFontIMG.width(),dateFontIMG.height()/11);
		yearshow=5;
	}
	
	p.drawPixmap(mouLeft,mouTop,dateFontIMG,0,tdate.month/10*dateFontIMG.height()/11,dateFontIMG.width(),dateFontIMG.height()/11);
		
	p.drawPixmap(mouLeft+dateFontIMG.width(),mouTop,dateFontIMG,0,tdate.month%10*dateFontIMG.height()/11,dateFontIMG.width(),dateFontIMG.height()/11);
		
	p.drawPixmap(MDLeft,MDTop,dateFontIMG,0,10*dateFontIMG.height()/11,dateFontIMG.width(),dateFontIMG.height()/11);
	
	p.drawPixmap(dayLeft,dayTop,dateFontIMG,0,tdate.day/10*dateFontIMG.height()/11,dateFontIMG.width(),dateFontIMG.height()/11);
		
	p.drawPixmap(dayLeft+dateFontIMG.width(),dayTop,dateFontIMG,0,tdate.day%10*dateFontIMG.height()/11,dateFontIMG.width(),dateFontIMG.height()/11);
}
void showPreview::drawLunar(QPainter &p)
{
	time_t rawtime;
	time ( &rawtime );
	timeinfo = localtime ( &rawtime );
	Date tdate;
	tdate.year=timeinfo->tm_year+1900;
	tdate.month=timeinfo->tm_mon+1;
	tdate.day=timeinfo->tm_mday;
	
	QString nltemp;
	GetDayOf(tdate,nltemp);
	QFont f("AMCSL",lunarFontSize);	//设置字体大小
	p.setFont(f);
	QPen pen(lunarFontColor,1);
	p.setPen(pen);

	p.drawText( lunarLeft,lunarTop, nltemp/*ctr(nltemp)*/ );
}
void showPreview::drawWeek(QPainter &p)
{
	time_t rawtime;
	time ( &rawtime );
	timeinfo = localtime ( &rawtime );
	
	p.drawPixmap(weekLeft,weekTop,weekResIMG,0,weekResIMG.height()/7*timeinfo->tm_wday,weekResIMG.width(),weekResIMG.height()/7);
}
void showPreview::drawBattery(QPainter &p)
{
	if(oldBatteryLevel!=UTIL_GetBatteryLevel())
		oldBatteryLevel=UTIL_GetBatteryLevel();

	int batNum;
	if(oldBatteryLevel>=3)
		batNum=oldBatteryLevel-2;
	else
		batNum=oldBatteryLevel/2;
	
	p.drawPixmap(batteryLeft, batteryTop, batteryLevel[batNum]);

}
void showPreview::drawSignal(QPainter &p)
{
	if(oldSignalLevel!=UTIL_GetSignalQuality())
		oldSignalLevel = UTIL_GetSignalQuality();

	p.drawPixmap(signalLeft, signalTop, signalLevel[oldSignalLevel]);
}
void showPreview::drawNotify(QPainter &p)
{
	QString str;
	QDate date = QDate::currentDate();
	QDate date2(notifyDestYear, notifyDestMonth, notifyDestDay);
	int i = date.daysTo(date2);
	if( i > -1 ) 
		str = lng->tr("距离 %1 还有 %2天").arg(notifyStr).arg(i);  
	else 
		str = lng->tr("距离 %1 已过 %2天").arg(notifyStr).arg( (uint)i );

	QFont f("AMCSL", notifyFontSize);	//设置字体大小
	if(notifyBold)
		f.setBold(true);		
	p.setFont(f);
	
	// text Shadow
	p.setPen(QColor(128,128,128));
	p.drawText( notifyLeft+1 ,notifyTop+1, str );
	
	// text
	QPen pen(notifyFontColor,1);
	p.setPen(pen);
	QFontMetrics fm = p.fontMetrics();
	
	p.drawText( notifyLeft ,notifyTop, str );
}
void showPreview::drawDockBar(QPainter &p)
{
	#ifdef DEBUG_DOCKBAR
	toLog("draw dock bar");
	#endif
	p.drawPixmap(dockBarBgLeft,dockBarBgTop, dockBarBgImg); //画背景
	
	for(int i=0;i<dockBarNum;i++) {
		#ifdef DEBUG_DOCKBAR
		toLog("draw icon"+QString::number(i));
		#endif
		float a, b;//, c;
		if(i == mDockBarWidgetIndex ) {
			a = (float)dockBarWidgetWidth[i]/(float)dockBarIcon[i].width();
			b = (float)dockBarWidgetHeight[i]/(float)dockBarIcon[i].height();		
		} else {		
			a = (float)dockBarSizeWidth[i]/(float)dockBarIcon[i].width();
			b = (float)dockBarSizeHeight[i]/(float)dockBarIcon[i].height();
		}	
		if(a<0) a = -a;
		if(b<0) b = -b;
		
		QWMatrix tmp;
		tmp.scale(a, b);		
		QPixmap now = dockBarIcon[i].xForm( tmp );
		p.drawPixmap(dockBarLeft[i], dockBarTop[i], now);	
	}
}

void showPreview::GetDayOf(Date &tdate,QString &strLuner) 
{ 
/*天干名称*/ 
const char *cTianGan[] = {"甲","乙","丙","丁","戊","己","庚","辛","壬","癸"}; 
/*地支名称*/ 
const char *cDiZhi[] = {"子","丑","寅","卯","辰","巳","午", 
"未","申","酉","戌","亥"}; 
/*属相名称*/ 
const char *cShuXiang[] = {"鼠","牛","虎","兔","龙","蛇", 
"马","羊","猴","鸡","狗","猪"}; 
/*农历日期名*/ 
const char *cDayName[] = {"*","初一","初二","初三","初四","初五", 
"初六","初七","初八","初九","初十", 
"十一","十二","十三","十四","十五", 
"十六","十七","十八","十九","二十", 
"廿一","廿二","廿三","廿四","廿五", 
"廿六","廿七","廿八","廿九","三十"}; 
/*农历月份名*/ 
const char *cMonName[] = {"*","正","二","三","四","五","六", 
"七","八","九","十","十一","腊"}; 

/*公历每月前面的天数*/ 
const int wMonthAdd[12] = {0,31,59,90,120,151,181,212,243,273,304,334}; 
/*农历数据*/ 
const int wNongliData[100] = 
{2635,333387,1701,1748,267701,694,2391,133423,1175,396438 
,3402,3749,331177,1453,694,201326,2350,465197,3221,3402 
,400202,2901,1386,267611,605,2349,137515,2709,464533,1738 
,2901,330421,1242,2651,199255,1323,529706,3733,1706,398762 
,2741,1206,267438,2647,1318,204070,3477,461653,1386,2413 
,330077,1197,2637,268877,3365,531109,2900,2922,398042,2395 
,1179,267415,2635,661067,1701,1748,398772,2742,2391,330031 
,1175,1611,200010,3749,527717,1452,2742,332397,2350,3222 
,268949,3402,3493,133973,1386,464219,605,2349,334123,2709 
,2890,267946,2773,592565,1210,2651,395863,1323,2707,265877}; 
static int wCurYear,wCurMonth,wCurDay; 
static int nTheDate,nIsEnd,m,k,n,i,nBit; 
//char szNongli[30], szNongliDay[10],szShuXiang[10]; 
/*---取当前公历年、月、日-- -*/ 
wCurYear = tdate.year; 
wCurMonth = tdate.month; 
wCurDay = tdate.day;
/*---计算到初始时间1921年2月8日的天数：1921-2-8(正月初一)---*/ 
nTheDate = (wCurYear - 1921) * 365 + (wCurYear - 1921) / 4 + wCurDay + wMonthAdd 
[wCurMonth - 1] - 38; 
if((!(wCurYear % 4)) && (wCurMonth > 2)) 
nTheDate = nTheDate + 1; 

/*--计算农历天干、地支、月、日---*/ 
nIsEnd = 0; 
m = 0; 
while(nIsEnd != 1) 
{ 
	if(wNongliData[m] < 4095) 
		k = 11; 
	else 
		k = 12; 
	n = k; 
	while(n>=0) 
	{ 
		//获取wNongliData(m)的第n个二进制位的值 
		nBit = wNongliData[m]; 
		for(i=1;i<n+1;i++) 
		nBit = nBit/2; 

		nBit = nBit % 2; 

		if (nTheDate <= (29 + nBit)) 
		{ 
			nIsEnd = 1; 
			break; 
		} 

		nTheDate = nTheDate - 29 - nBit; 
		n = n - 1; 
	} 
	if(nIsEnd) 
		break; 
	m = m + 1; 
} 
wCurYear = 1921 + m; 
wCurMonth = k - n + 1; 
wCurDay = nTheDate; 
if (k == 12) 
{ 
	if (wCurMonth == wNongliData[m] / 65536 + 1) 
		wCurMonth = 1 - wCurMonth; 
	else if (wCurMonth > wNongliData[m] / 65536 + 1) 
		wCurMonth = wCurMonth - 1; 
} 

/*--生成农历天干、地支、属相 ==> wNongli--*/ 

strLuner =  ctr( cShuXiang[((wCurYear - 4) % 60) % 12] );
strLuner          +=  ctr("\(");
strLuner          += ctr( cTianGan[((wCurYear - 4) % 60) % 10] );
strLuner          += ctr( cDiZhi[((wCurYear - 4) % 60) % 12] );
strLuner          += ctr( ")年" );

/*--生成农历月、日 ==> wNongliDay--*/ 
if (wCurMonth < 1)
{
 	strLuner = strLuner +  ctr( "闰" )
         	+  ctr( cMonName[-1 * wCurMonth] );
}
else
{
	strLuner = strLuner +  ctr( cMonName[wCurMonth] );
}
strLuner = strLuner +  ctr( "月" )
           +  ctr( cDayName[wCurDay] );

} 

