
#ifndef SHOWPREVIEW_H
#define SHOWPREVIEW_H

#include <ZKbMainWidget.h>
#include <ZSoftKey.h>

#include <RES_ICON_Reader.h>

#include <qpixmap.h>
#include <qtimer.h>
#include <time.h>
#include <qdatetime.h>
#include <qdir.h>
#include <iostream>


#include "tool.h"
#include "BaseDlg.h"

typedef struct tagDate		//日期格式
{
  //int sec;
  //int min;
  //int hour;
  int day;
  int month;
  int year;
}Date,*PDate;


class  showPreview: public MyBaseDlg
{
	Q_OBJECT
	public:
		showPreview(QString &skinDir);
		~showPreview();	
		
		void plugin_init();
		//void setBG();
		void paintEvent( QPaintEvent *);
	public slots:
		//void slotSystemMessage(const QCString &,const QByteArray &);
		//void timerEvent();  //darw screen
		void slotQuit();
	private:
		
		
		void GetDayOf(Date &tdate,QString &strLuner);
		void drawCenter(QPainter &p);
		void drawAnalog(QPainter &p);
		void drawDigital(QPainter &p);
		void drawDate(QPainter &p);
		void drawLunar(QPainter &p);
		void drawWeek(QPainter &p);
		void drawBattery(QPainter &p);
		void drawSignal(QPainter &p);	
		void drawNotify(QPainter &p);
		void drawDockBar(QPainter &p);
		
		QString mSkinDir;
		
		struct tm * timeinfo;
		
		RES_ICON_Reader iconReader;
		
		QPixmap nowScreen;
		int softKeyHeight;

		QString skinName;
		QString author;
		QString skinPath;
	//Background
		bool useDefault;
		QPixmap backIMG;
		QPixmap fmIMG;
		QPixmap centerIMG;
		//QString layout;
	//Analog                
		bool analogShow;
		QPixmap analogBackIMG;
		QPixmap analogCenterIMG;
		QPixmap analogSecIMG;
		QPixmap analogMinIMG;
		QPixmap analogHourIMG;
		bool analogSecShow;
		int analogLeft;
		int analogTop;
	//Digital              ok
		bool digitalShow;
		QPixmap digitalFontIMG;
		bool digitalSecShow;
		int DHLeft;
		int DHTop;
		int HMLeft;
		int HMTop;
		int DMLeft;
		int DMTop;
		int MSLeft;
		int MSTop;
		int DSLeft;
		int DSTop;
	//Week                ok
		bool weekShow;
		QPixmap weekResIMG;
		int weekLeft;
		int weekTop;
	//[Date]             ok
		bool dateShow;
		QPixmap dateFontIMG;
		bool dateYearShow;
		int yearLeft;
		int yearTop;
		int YMLeft;
		int YMTop;
		int mouLeft;
		int mouTop;
		int MDLeft;
		int MDTop;
		int dayLeft;
		int dayTop;
	//[Lunar]           ok
		bool lunarShow;
		int lunarFontSize;
		long lunarFontColor;
		int lunarLeft;
		int lunarTop;
	//[Battery]           ok
		bool batteryShow;
		//bool batteryUseDefault;
		QPixmap batteryLevel[4];
		int batteryLeft;
		int batteryTop;
		
		int oldBatteryLevel;		
	//[Signal]              ok
		bool signalShow;
		//bool signalUseDefault;
		QPixmap signalLevel[6];
		int signalLeft;
		int signalTop;
		
		int oldSignalLevel;
	
	//[Notify]
		bool notifyShow;
		bool notifyBold;
		int notifyFontSize;
		int notifyLeft;
		//int notifyOffset;
		int notifyTop;
		QColor notifyFontColor;
		
		int notifyDestYear;
		int notifyDestMonth;
		int notifyDestDay;
		QString notifyStr;
		
	//[DockBar]	
		bool dockBarShow;
		int dockBarNum;
		int dockBarBgTop; //背景上边界
		int dockBarBgLeft; //背景右边界
		int dockBarTop[10]; //每一个项相对上边的偏移
		int dockBarLeft[10]; //每一个项相对右边的便宜
		int dockBarSizeHeight[10]; //未选中状态下的高
		int dockBarWidgetHeight[10]; //选择状态下的高
		int dockBarSizeWidth[10]; //未选中状态下的宽
		int dockBarWidgetWidth[10]; //选中状态下的宽
		
		bool dockBarInfoShow; //
		int dockBarInfoFontSize[10]; 
		int dockBarInfoFontLeft[10];
		int dockBarInfoFontTop[10];
		QColor dockBarInfoFontColor[10];
		QString dockBarInfoContent[10];	
		
		QPixmap dockBarIcon[10]; //每一个项的容器
		QPixmap dockBarBgImg; //dock bar 背景容器
		//QPixmap dockBarCover;
		int mDockBarWidgetIndex; //全局下光标选中dockbar的项目		

};

#endif


