
#include "showSlider.h"

showSliderDlg::showSliderDlg(QString &title, QString &text, int min, int val, int max) : ZPopup()
{
	min_data=min;
	max_data=max;

	ret=val;
	isCancel=false;

	setTitle(title);
	setInstructText(text);

	setTitleIcon("action_required_pop.bmp");

	module = new ZSliderModule(
		min, max, 1, val,
		(ZSlider::Indicator)0, 0, 0, (ZSkinService::WidgetClsID)33);
	insertChild(module);

	char str[20];
	sprintf(str, "%d -%d- %d", min, val, max);
	module->updateLabel(str);

	ZSlider *slider = module->getSlider();
    module->setAlignment(ZSliderModule::BOTTOM);
    slider->setOrientation( ZSlider::Horizontal );
	slider->showThumb(true);

	connect(slider, SIGNAL(valueChanged(int)), this, SLOT(valChanged(int)));

	softkey=getSoftKey();
	softkey->setText(ZSoftKey::LEFT,  tr("TXT_RID_SOFTKEY_OK", "Ok"));
	softkey->setText(ZSoftKey::RIGHT, tr("TXT_RID_OPTION_CANCEL", "Cancel"));

	softkey->setClickedSlot(ZSoftKey::LEFT, this, SLOT(ok()));
	softkey->setClickedSlot(ZSoftKey::RIGHT, this, SLOT(cancel()));
}

void showSliderDlg::valChanged(int x)
{
	ret=x;

	char str[20];
	sprintf(str, "%d -%d- %d", min_data, ret, max_data);
	module->updateLabel(str);
}

void showSliderDlg::ok()
{
	isCancel=false;
	reject();
}

void showSliderDlg::cancel()
{
	isCancel=true;
	reject();
}

