/******************************
RokrDeskPlugin interface
by wanggjghost(泪の单翼天使)
Based on Desktop Plugin Kit - ZMyScreenPlugin by Ant-ON
Special thanks to 夏日清泉（Justin.Z）

www.591moto.cn
41245110@qq.com
please keep author information if you redistribute this program

**********************************/

#include <ZConfig.h>
#include <ZListBoxItem.h>
#include <ZMessageDlg.h>

#include <qdir.h>
#include <qtextcodec.h>
#include <qcopchannel_qws.h>

#include <iostream>

#include "skinDlg.h"
#include "lng.h"

extern Lng *lng;

using namespace std;

skinDlg::skinDlg() :ZPopup()
{
	appDir = getAppDir();
	isCancel = false;
	
	this->setTitle(lng->tr("FT_CHG_THEME"));
	this->setTitleIcon(iconReader.getIcon("fm_folder_small.bmp"));

	QRect rect=ZGlobal::getContentR();
		
    listBox = new ZListBox("%I%M",this);	
	listBox->enableMarquee(ZListBox::LISTITEM_REGION_A, true);
	listBox->enableMarquee(ZListBox::LISTITEM_REGION_B, true);		
	this->insertChild(listBox);
	
	softKey = this->getSoftKey();
	softKey->setText(ZSoftKey::LEFT,  lng->tr("FT_PREVIEW"));
    softKey->setText(ZSoftKey::RIGHT, lng->tr("FT_BACK"));
	
	softKey->setClickedSlot(ZSoftKey::LEFT, this ,SLOT( slotPreview() ));
	softKey->setClickedSlot(ZSoftKey::RIGHT, this ,SLOT( slotQuit() ));

	connect( listBox, SIGNAL ( selected ( int ) ), this, SLOT ( itemSelected( int ) ) );	
	//connect( listBox, SIGNAL ( highlighted ( int ) ), this, SLOT ( itemHighlighted ( int ) ) );
	
	initList();
		
}

skinDlg::~skinDlg()
{
	objList.setAutoDelete(TRUE);
	objList.clear();
	//printf("dlg quite\n");
}

void skinDlg::initList()
{
	bulidSkinList();
	
	listBox->clear();
	append2_ui(listBox, objList);
}

void skinDlg::bulidSkinList()
{
	QDir dir(DESK_SKIN_PATH);
	if(!dir.isReadable()) 
		return;
	
	struct skinObj *obj = NULL;
	int mark;
	
	objList.setAutoDelete(TRUE);
	objList.clear();
		
	dir.setFilter(QDir::Dirs | QDir::NoSymLinks);
	
	QStringList entries;
	QStringList::Iterator p;

	entries = dir.entryList();
	entries.sort();
	
	for (p=entries.begin(); p!=entries.end(); p++)
	{
		mark = 0;
		if ( *p == "." || *p == ".." ) continue;	
		obj = new skinObj; 
		obj->dir = *p;
		ZConfig cfg(DESK_SKIN_PATH+*p+"/skin.cfg");
		cout<<"cur cfg is "<<DESK_SKIN_PATH+*p+"/skin.cfg"<<endl;
		obj->author = cfg.readEntry("General", "Author", "");
		if(obj->author != "") mark++;
		obj->name = cfg.readEntry("General", "SkinName", "");
		if(obj->name != "") mark ++;
		
		if(mark == 0)
		{
			delete obj;
			continue;
		}
		objList.append(obj);
	}
}

void skinDlg::append2_ui(ZListBox *target, QList<struct skinObj> list)
{
	ZListBoxItem *pItem = NULL;
	QPixmap pm(appDir+"/img/skin.png");
	
	struct skinObj *obj = list.first(); 
	
	while(obj != NULL)
	{
		pItem = new ZListBoxItem(target);
		pItem->appendSubItem(1, obj->name);
		pItem->appendSubItem(1, lng->tr("FT_AUTHOR")+obj->author);
		pItem->setPixmap(0, pm);
		
		target->insertItem(pItem);
		
		obj = list.next();
	}
}

void skinDlg::slotQuit()
{
	printf("slot quite\n");
	//this->close();
	isCancel = true;
	reject();
}
void skinDlg::slotOK()
{
	isCancel = false;
	reject();
}
void skinDlg::slotPreview()
{

	struct skinObj *obj = NULL;
	int index = listBox->currentItem();
	if (index != -1) 
		obj = objList.at(index);
	else
		return;	
	
	QString dir = obj->dir;
	cout<<"===== cur dir "<<dir<<" ======="<<endl;
	showPreview *dlg = new showPreview( dir );
	dlg->exec();
	delete dlg;
	dlg = NULL;
}

void skinDlg::itemSelected(int index)
{
	printf("click item %d\n", index);
	struct skinObj *obj = objList.at(index);
	
	ZMessageDlg *dlg = new ZMessageDlg(lng->tr("FT_CHG_THEME"), lng->tr("FT_CONFIRM_USE")+obj->name, (ZMessageDlg::MessageDlgType)1);
	int ret = dlg->exec();
	if(ret == 1)
	{
		curSkin = obj->dir;
		slotOK();
	}	
}

